_me = frm_backup.prototype;
function frm_backup(){};

_me.__constructor = function() {

	var me = this;

	this._size(700,400,true);

	this._title(GWOthers.getItem('RESTRICTIONS','disable_export')>0?'BACKUP::IMPORT':'MAIN_MENU::IMPORT_EXPORT');

	this._draw('frm_backup','main',{disable_export:GWOthers.getItem('RESTRICTIONS','disable_export')>0});

	this._activeFolder = this._activeFolder2 = Mapping.getDefaultFolderForGWType('C');
	this.__changeFolder(sPrimaryAccount,this._activeFolder);
	this.__changeFolder2(sPrimaryAccount,this._activeFolder2);

	storage.library('wm_import');

	if (this.maintab.csv){
		this.maintab.csv.folders._onclick = function(){
			gui._create('frm_select_folder','frm_select_folder','','','POPUP_FOLDERS::SELECT_FOLDER',sPrimaryAccount,me._activeFolder2,[me,'__changeFolder2'],true,true,'C','',true);
		};
		this.maintab.csv['export']._onclick = function(){
			downloadItem(buildURL({
				'sid':dataSet.get('main',['sid']),
				'class':'exportcsv',
				'fullpath':sPrimaryAccount+ '/' + me._activeFolder2 +'/'+ this._parent.separator._value()
			}));
		};
	}

	//Groupware
	if (this.maintab.gw.export_gw)
		this.maintab.gw.export_gw._onclick = function(){
			downloadItem('sid='+dataSet.get('main',['sid'])+'&class=groupware&fullpath='+ sPrimaryAccount);
		};

	this.maintab.gw.import_gw._onuploadend = function(arg){
		arg = arg[arg.length-1];
		if (arg.folder && arg.id){
			var oImport = new wm_import(), str = '';
			if (oImport.import_data({'action':'groupware','account':sPrimaryAccount,'path':(arg.folder +'/'+ arg.id)}))
				str = 'BACKUP::IMPORT_SUCCESSFUL';
			else
                str = 'BACKUP::IMPORT_UNSUCCESSFUL';

            gui._create('backup_alert','frm_alert','','','','',str);
		}
	};


	this.maintab.contact.step3._onuploadend = function(arg){
		if ((arg = arg[arg.length-1]) && arg.folder && arg.id){
			me.__value = arg;

			switch(arg.name.substr(arg.name.lastIndexOf('.')+1).toLowerCase()){
			case 'txt':
			case 'csv':
				me.__value.action = 'csv';
				break;
			case 'ldif':
				me.__value.action = 'ldif';
				break;
			case 'vcf':
				me.__value.action = 'vcard';
				break;
			case 'vcs':
			case 'ics':
				me.__value.action = 'vcalendar';
				break;

			default:
                gui._create('backup_alert','frm_alert','','','','','BACKUP::UNKNOWN_EXT');
				return;
			}

			//Set Folder
			var sFolderType = dataSet.get("folders",[sPrimaryAccount,me._activeFolder,'TYPE']);
			if (me.__value.action == 'vcalendar'){
				if (sFolderType != 'E')
					me._activeFolder = Mapping.getDefaultFolderForGWType('E');
			}
			else
			if (sFolderType != 'C')
				me._activeFolder = Mapping.getDefaultFolderForGWType('C');
			me.maintab.contact.folders._title(me._activeFolder);
			me.maintab.contact.folders._disabled(false);

			//Import button
			me.maintab.contact['import']._disabled(false);
			me.maintab.contact['import']._onclick = function (){
				var oImport = new wm_import();
				var result = oImport.import_data({'action':me.__value.action,'folder':me._activeFolder,'lines':(me.__value.action=='csv'?5:0),'account':sPrimaryAccount,'path':(me.__value.folder +'/'+ me.__value.id)});
				var elm = document.getElementById(this._parent._pathName+'csv');

				if (me.__value.action == 'csv' && Is.Array(result)){
					removecss(elm,'hidden');
					this._parent.step4._fill(result);
					this._parent.step5._disabled(false);
				}
				else{
                    gui._create('backup_alert','frm_alert','','','','',result?'BACKUP::IMPORT_SUCCESSFUL':'BACKUP::IMPORT_UNSUCCESSFUL');

					addcss(elm,'hidden');
					me.maintab.contact.folders._disabled(true);
					me.__value = null;
				}

				this._disabled(true);
			};

		}
		return true;
	};


	//IMPORT BUTTON
	this.maintab.contact.step5._onclick = function(){
		if (me.__value.folder && me.__value.id){

			var aData = this._parent.step4._value();

			if (!count(aData)){
				gui._create('import_error','frm_alert','','','','','BACKUP::SELECT_COL');
				return;
			}
			else
			if(!aData.LOCATIONS){
				gui._create('import_error','frm_alert','','','','','BACKUP::SELECT_EMAIL');
				return;
			}

			var oImport = new wm_import();
			var result = oImport.import_data({'action':'csv',values:aData,'folder':me._activeFolder,'account':sPrimaryAccount,'skipfirst':this._parent.step4x._value()?true:false,'share':this._parent.step4y._value()=='*'?'':this._parent.step4y._value(),'path':(me.__value.folder +'/'+ me.__value.id)});

			if (result){
				this._parent.step4._fill();
				me.__value = null;

				var elm = document.getElementById(this._parent._pathName+'csv');
				addcss(elm,'hidden');
				
				gui._create('import_error','frm_alert','','','','','BACKUP::IMPORT_SUCCESSFUL');

				//AutoUpdate
				if (dataSet.get('active_folder') == sPrimaryAccount +'/'+ me._activeFolder && gui.frm_main)
					gui.frm_main._refreshItems(sPrimaryAccount);
			}
			else
				gui._create('import_error','frm_alert','','','','','BACKUP::IMPORT_UNSUCCESSFUL');
		}
	};

	this.maintab.contact.folders._onclick = function(){
		var sFolderType = dataSet.get("folders",[sPrimaryAccount,me._activeFolder,'TYPE']);

		if (sFolderType != 'C')
			sFolderType = ['E','T','N','J'];
		
		gui._create('frm_select_folder','frm_select_folder','','','POPUP_FOLDERS::SELECT_FOLDER',sPrimaryAccount,me._activeFolder,[me,'__changeFolder'],true,true,sFolderType,'',true);
	};
	
};

_me.__changeFolder = function(sAccount,sFolder){
	this._activeFolder = sFolder;
	this.maintab.contact.folders._title(Path.basename(dataSet.get('folders',[sAccount,sFolder,'NAME']) || sFolder));
};
_me.__changeFolder2 = function(sAccount,sFolder){
	this._activeFolder2 = sFolder;

	if (this.maintab.csv)
		this.maintab.csv.folders._title(Path.basename(dataSet.get('folders',[sAccount,sFolder,'NAME']) || sFolder));
};