_me = frm_file.prototype;
function frm_file(){};

_me.__constructor = function() {
	var me = this;

	this._defaultSize(-1,-1,450,310);

	this._draw('frm_file', 'main', {folders:(this._aValues.fullpath)?true:false,ticket_url:(this._aValues.TICKET?true:false)});

	if (Is.Empty(this._aValues)){
		this._create('X_ATTACHMENTS','obj_upload_edit','attach');
		this.X_NAME._disabled(true);
	}
	else{
		this._create('X_ATTACHMENTS','obj_upload_edit_single','attach');
		this.X_ATTACHMENTS._oncontext = null;

		if (this._aValues.TICKET){
			this.X_TICKET._onclick = function(){
	        	this._setRange(0,this._value().length);
			};
			this.X_TICKET._readonly(true);
			this.X_TICKET._value(this._aValues.TICKET);
		}
	}

	this.x_btn_ok._disabled(true);
	this.X_NAME._onerror = function(b){
		me.x_btn_ok._disabled(b);
	};

	this.__initForm('FILE::FILE');

	if (this.x_folders)
		this.x_folders._onclick = function(){
			gui._create('frm_select_folder','frm_select_folder','','','POPUP_FOLDERS::SELECT_FOLDER',me._sAccountID,me._sFolderID,[me,'__changeFolder'],true,true,'F','w',false);
		};

	//remove contextmenu
	this.X_ATTACHMENTS._onuploadstart = function(){
        if (this._parent.x_btn_ok)
			this._parent.x_btn_ok._disabled(true);
		if (this._parent.x_btn_cancel)
			this._parent.x_btn_cancel._disabled(true);
	};
	
    this.X_ATTACHMENTS._onchange = function(){
		me.__checkEnableForm();
	};
	this.X_ATTACHMENTS._onuploadend = function(){
		me.__checkEnableForm();
		if (this._parent.x_btn_cancel)
			this._parent.x_btn_cancel._disabled(false);
	};
};

//Update Save As
_me.__checkEnableForm = function(){
	var count = 0,
		v = this.X_ATTACHMENTS._value();
		
	for (var i in v)
	    if(v[i].values && v[i].values.description){
            count++;
			this.X_NAME._value(v[i].values.description);
	    }

	if (!count || count>1){
		this.X_NAME._disabled(true);
	    if (this.x_btn_ok)
			this.x_btn_ok._disabled(!count);
	}
	else{
		this.X_NAME._disabled(false);
        if (this.x_btn_ok)
			this.x_btn_ok._disabled(!this.X_NAME.__check());
	}
};

_me.__print = function(aValues){
	aValues = aValues.values;
	
	if (!gui.print)
		gui._create('print','frm_print');

	gui.print._template('print_file',aValues);
};

_me.__loadItems = function() {
	loadDataIntoForm(this, this._aValues);

	if (!this._aValues['EVN_ID'])
		this.EVNSHARETYPE._value(GWOthers.getItem('DEFAULT_CALENDAR_SETTINGS','file_sharing'));

	if (this._aValues['ATTACHMENTS']){

		var out;
		for (var i in this._aValues['ATTACHMENTS']) {
			out = {'name': this._aValues['ATTACHMENTS'][i]['values']['ATTDESC'], 'class': this._aValues['ATTACHMENTS'][i]['values']['ATTTYPE'], 'id': i, 'size': this._aValues['ATTACHMENTS'][i]['values']['ATTSIZE']};

			//Update Save As
			this.X_NAME._value(this._aValues['ATTACHMENTS'][i]['values']['ATTDESC']);
			break;
		}

		if (this._aValues.fullpath){
			out.fullpath = this._aValues.fullpath;
			this.X_ATTACHMENTS._value({'values': [out]});
		}
		else
			this.X_ATTACHMENTS._value({'path': this._sAccountID+'/'+this._sFolderID+'/'+WMItems.__serverID(this._sItemID), 'values': [out]});
	}
	else
	if (this._aValues['PUSH_ATTACHMENTS']){
        this.X_ATTACHMENTS._value({path:this._aValues['PUSH_ATTACHMENTS'][0]['fullpath'].substr(0,this._aValues['PUSH_ATTACHMENTS'][0]['fullpath'].lastIndexOf('/')),
									values:[{
										'name': this._aValues['PUSH_ATTACHMENTS'][0]['title'],
										'id': this._aValues['PUSH_ATTACHMENTS'][0]['id'],
										'size': this._aValues['PUSH_ATTACHMENTS'][0]['size'],
										'class': this._aValues['PUSH_ATTACHMENTS'][0]['embedded'] ? 'item' : 'itemlink',
										'fullpath': this._aValues['PUSH_ATTACHMENTS'][0]['fullpath']
									}]});

		this.__checkEnableForm();
	}
};

_me.__changeFolder = function(sAccount,sFolder){
	this._sAccountID = sAccount;
	this._sFolderID = sFolder;
	this._id = [sAccount, sFolder];
};

_me.__saveItems = function(aValues) {
	var addon;
	if (!Is.Empty(addon = this.X_ATTACHMENTS._value())) {
		var now = new Date();

		aValues['values']['EVNLOCATION'] = aValues['values']['EVNTITLE'] = addon[addon.length-1]['values']['description'];
		aValues['values']['EVNRID'] = aValues['values']['EVNLOCATION'];
		aValues['values']['EVNCOMPLETE'] = this.X_ATTACHMENTS._getSize();
		aValues['values']['EVNSTARTDATE'] = now.getJulianDate();
		aValues['values']['EVNSTARTTIME'] = now.getHours()*60 + now.getMinutes();

		//EDIT since 7.10.2009 13:42:20
		if (!Is.Empty(this._aValues) && addon.length>1){
            addon[1].uid = addon[0].uid;
            addon.shift();
		}

		aValues['ATTACHMENTS'] = addon;
	}
	
	//Uploaded Attachment
	if (aValues.ATTACHMENTS){
		if (!this.X_NAME._disabled() && aValues.ATTACHMENTS[0].values && aValues.ATTACHMENTS[0].values.description != this.X_NAME._value())
			aValues.values.EVNTITLE = aValues.values.EVNLOCATION = aValues.values.EVNRID = aValues.ATTACHMENTS[0].values.description = this.X_NAME._value();
	}
	//Edited Attachment
	else
	if (this._aValues.ATTACHMENTS)
	    for (var i in this._aValues.ATTACHMENTS)
	        if (this._aValues.ATTACHMENTS[i].values && this._aValues.ATTACHMENTS[i].values.ATTDESC != this.X_NAME._value()){
				aValues.ATTACHMENTS = [{'uid':i,'values':{'description':this.X_NAME._value()}}];
				aValues.values.EVNTITLE = aValues.values.EVNLOCATION = aValues.values.EVNRID = this.X_NAME._value();
				return;
			}
};