_me = frm_im_add.prototype;
function frm_im_add(){};

/**
 * @brief
 * 
 * @see  IM/new group
 */
_me.__constructor = function(xmpp, sGroup, sJID, sName,sTab) {

	var me = this;

	this._size(470,360,true);
	this._resizable  = false;

	this._title('FORM_BUTTONS::ADD');

	this._draw('frm_im_add','main');


    this.__gateways = [];
    
	// Create 'OK' button
    this._create('btn_ok', 'obj_button', 'footer');

	// Create 'CANCEL' button
	this._create('btn_cancel', 'obj_button', 'footer');
	this.btn_cancel._value('FORM_BUTTONS::CANCEL');
	this.btn_cancel._onclick = function() {
		me._destruct();
	};

	this.maintab.user._onactive = function (bFirstTime){
		if (bFirstTime){
			if (sJID)
				this.jid._value(sJID);

			if (sName)
				this.nick._value(sName);

			var aGroups = {'*':getLang('IM::UNSORTED')},
				aGW = {'*':getLang('SETTINGS::DEFAULT')},
				aRoster = dataSet.get('xmpp', ['roster']);

			if (aRoster)
				for(var i in aRoster){
					if (aRoster[i].group && !aGroups[aRoster[i].group])
						aGroups[aRoster[i].group] = aRoster[i].group;

					if (i.indexOf('@')<0)
						aGW[i] = i;
				}

			this.group._fill(aGroups);
			this.group._value(sGroup || '*');

			this.gateway._fill(aGW);
			this.gateway._value('*');
			this.gateway._onchange = function(){
				if (aGW[this._parent.group._value()])
					this._parent.group._value(this._value());
			};

			this.group._onsubmit = this.nick._onsubmit = this.jid._onsubmit = function (){me.btn_ok._onclick();}
			this.group._onclose = this.nick._onclose = this.jid._onclose = function (){me.btn_cancel._onclick();}
		}

		//nastavit buttony
		me.btn_ok._value('FORM_BUTTONS::OK');
		me.btn_ok._onclick = function(){
			var jid = me.maintab.user.jid._value();
			if (jid){
				if (me.maintab.user.gateway._value() != '*')
					jid = jid.replace('@','%')+'@'+me.maintab.user.gateway._value();

				executeCallbackFunction([xmpp,'user_add'],jid,me.maintab.user.nick._value(),me.maintab.user.group._value());
				me._destruct();
			}
		};
	};

	this.maintab.gateway._onactive = function (bFirstTime){
		if (bFirstTime){
			this.grid.__sortColumn = 'name';
			this.grid._addColumns({
                'check':{width:20,arg:{sort:'asc'},'css':'check',"type":'static',"text":'&nbsp;'},
				'name':{title:"DATAGRID_ITEMS_VIEW::NAME",width:160,arg:{sort:'asc'}},
				'jid':{title:"IM::JABBER_ID",width:160,arg:{sort:'asc'}},
				'type':{title:"DATAGRID_ITEMS_VIEW::TYPE",width:80,arg:{sort:'asc'}}
			});

			this.grid._ondblclick = function(){
				me.btn_ok._onclick();
			};

            //Load Gateways
			xmpp.gateway_list(dataSet.get('main',['domain']),[me,'_refresh']);
		}

		me.btn_ok._value('IM::REGISTR');
		me.btn_ok._onclick = function (){
			var v = me.maintab.gateway.grid._value();
			if (v && v[0] && me.maintab.gateway.grid._aData[v[0]])
				gui._create('addgtw','frm_im_addgtw','','',xmpp,me.maintab.gateway.grid._aData[v[0]].id,sGroup);
		};
	};

	if (sTab == 'gateway')
        this.maintab._value('gateway');
	else
		this.maintab.user._onactive(true);
};

_me._refresh = function(aResponse){
/*
 [QUERY]
.. [0]
.... [ITEM]
...... [0]
........ [ATTRIBUTES]
.......... [JID](string) = 007guard.com
.......... [CATEGORY](string) = gateway
.......... [TYPE](string) = icq
.......... [NAME](string) = 007guard.com
.... [ATTRIBUTES]
...... [XMLNS](string) = http://jabber.org/protocol/disco#items
 [ATTRIBUTES]
.. [TYPE](string) = result
.. [ID](string) = 7806114882435644001244646523706
.. [FROM](string) = merakdemo.com
.. [TO](string) = admin@merakdemo.com/Webmail
*/
	if (aResponse && aResponse.ATTRIBUTES && aResponse.ATTRIBUTES.TYPE == 'result'){
		var aData = [];
		for (var i in aResponse.QUERY[0].ITEM)
			if (aResponse.QUERY[0].ITEM[i].ATTRIBUTES.CATEGORY == 'gateway')
				aData.push({
				id:aResponse.QUERY[0].ITEM[i].ATTRIBUTES.JID,
				data:{
				'name':aResponse.QUERY[0].ITEM[i].ATTRIBUTES.NAME,
				'jid':aResponse.QUERY[0].ITEM[i].ATTRIBUTES.JID,
				'type':aResponse.QUERY[0].ITEM[i].ATTRIBUTES.TYPE
				}});

		this.__gateways = aData;
		this.__update();
		
		dataSet.obey(this,'','xmpp',true);
	}
};

_me.__update = function(sName, aDPath){
	if (this.__gateways.length && (!aDPath || aDPath[0]=='roster')){
		var aRoster = dataSet.get('xmpp', ['roster']);
		if (aRoster)
			for(var i in this.__gateways)
				if (aRoster[this.__gateways[i].id])
					this.__gateways[i].css = 'check';
				else
					delete this.__gateways[i].css;

		this.maintab.gateway.grid._serverSort(this.__gateways);
	}
};