_me = frm_insert_item.prototype;
function frm_insert_item(){};

_me.__constructor = function(aResponse, sAccount, sFolder, sType, sRight) {

	var me = this;

	this._dataSet = 'tmp_'+this._name;
	this.__value = null;

	this._title('INSERT_ITEM::INSERT_ITEM');
	this._size(800,500,true);

	// Create formular from template
	this._draw('frm_insert_item', 'main');

	//TREE
	this._create('tree_folder','obj_tree_folder','tree','',sAccount, sType);

	this.tree_folder._open((sAccount || sPrimaryAccount));
	this.tree_folder._onclick = function(e,elm,id,arg){
		if (e.type != 'contextmenu' && arg['aid'] && arg['fid']){

			var sType = dataSet.get("folders",[arg['aid'],arg['fid'],'TYPE']);
			
			if (me.radio)
				if (sType == 'M'){
					me.radio._disabled(true);
					me.radio._value('embedded');
					me._search(sType, arg['fid']);
				}
				else{
					me.radio._disabled(false);
					me._search(sType);
				}

            me.datagrid._SQLfilter = '';
			me.datagrid._SQLfulltext = '';
			me.datagrid._serverSort(arg);
		}
	};

	//DATAGRID
	this.datagrid._select_single = true;
	this.datagrid._listen_data(this._dataSet,'',true);
	this.datagrid._onchange = function(){
		if (this.__value.length>0){
			var f = this._getFolder();
			me.__value = {};
			me.__value[this.__value[0]] = dataSet.get(this._listener_data,[f.aid,f.fid,this.__value[0]]);
		}
	};
	this.datagrid._ondblclick = function(){
		me.x_btn_ok._onclick();
	};

	//Open folder
	var sType;
	if (sFolder && (sType = dataSet.get("folders",[(sAccount || sPrimaryAccount),sFolder,'TYPE']))){
		this.tree_folder._setActive ((sAccount || sPrimaryAccount)+'/'+sFolder);
		this.datagrid._serverSort({aid:(sAccount || sPrimaryAccount),fid:sFolder});

		if (sType == 'M')
			me._search(sType,sFolder);
		else
			me._search(sType);
	}

	// This function is triggered when 'OK' button is pressed.
	this.x_btn_ok._onclick = function() {

		var aItem,v = me.datagrid._value();
		if (v.length && (aItem = me.__value[v[0]])){

			var sTitle,
				sType = dataSet.get("folders", [aItem.aid, aItem.fid, 'TYPE']);

			switch (sType) {
				case 'M': sTitle = aItem['SUBJECT']; break;
				case 'C': sTitle = aItem['ITMCLASSIFYAS']; break;
				case 'F': sTitle = aItem['EVNLOCATION']; break;
				case 'E':
				case 'J':
				case 'N':
				case 'T': sTitle = aItem['EVNTITLE']; break;
				default:  sTitle = getLang('INSERT_ITEM::UNTITLED');
			}

			var aResult = [{
				'id': v[0],
				'title': sTitle,
				'fullpath': aItem.aid+'/'+aItem.fid+'/'+WMItems.__serverID(v[0]),
				'embedded': me.radio._value() == 'embedded',
				'aid':aItem.aid,
				'fid':aItem.fid
				}];

			if (sType == 'F')
				aResult[0].size = aItem.EVNCOMPLETE;
		}

		if (Is.Defined(aResponse))
			executeCallbackFunction(aResponse, aResult);

		me._destruct();
	};

	this._onclose = function() {
		dataSet.remove(me._dataSet);
		return true;
	};
};

_me._search = function (sType, sFolder){
	this._create('search', 'obj_item_search_'+ sType.toLowerCase(),'search','',sFolder);
	this.search._onsearch = function(v,s){
		this._parent.datagrid._SQLfilter = v;
		this._parent.datagrid._SQLfulltext = s;
        this._parent.datagrid._serverSort();
	};
};