_me = frm_reminder.prototype;
function frm_reminder(){};

_me.__constructor = function() {
	var me = this;

	this._size(400,180,true);
	
	this._title('REMINDER::REMINDER');

	this._create('items','obj_listbox_checked');

	this._draw('frm_reminder', 'footer');

	this.items._ondblclick = function(){
		var v = this._value();
		if (v.length && (v = v[0]))
			if (this.__aData[v].arg.aid && this.__aData[v].arg.fid && this.__aData[v].arg.iid)
				Item.open([this.__aData[v].arg.aid,this.__aData[v].arg.fid,this.__aData[v].arg.iid]);
	};

	// All reminders are snoozed by 5min on close by [x]
	this._onclose = function(b){
		if (b){
			var aID = me.__getIds(true);
			if (aID.length)
				WMItems.reminders({rid:aID,snooze:5},[me,'__handler']);
		}

		return true;
	};

	// define 'Snooze' button
	this.btn_snooze._onclick = function() {
		var aID = me.__getIds();
		if (aID.length)
			WMItems.reminders({rid:aID,snooze:me.snooze._value()},[me,'__handler']);
	};

	// define 'Dismiss' button
	this.btn_dismiss._onclick = function() {
		var aID = me.__getIds();
		if (aID.length)
			WMItems.reminders({rid:aID},[me,'__handler']);
	};
	this.btn_dismiss._focus();
};

_me.__getIds = function(bAll){
	var aID = [];
	for(var i in this.items.__aData)
	    if (this.items.__aData[i].checked || bAll)
	    	aID.push(this.items.__aData[i].arg.rid);

	return aID;
};

_me._fill = function(aData){
	var out = {};
	for(var i in aData){
	    out[i] = {
			title:(aData[i].title || getLang('EVENT_VIEW::NOTITLE')) + (aData[i].startdate>0 && aData[i].starttime>-1?' ('+ (new Date()).setGWTime(aData[i].startdate,aData[i].starttime).toWMString() +')':''),
			checked: !this.items.__aData || !this.items.__aData[i] || this.items.__aData[i].checked?true:false,
			css: 'reminder_'+aData[i]['class'],
			arg:aData[i]
			};
			
		//Title
		if (gui.frm_main && gui.frm_main.title && (!this.items.__aData || !this.items.__aData[i]))
			gui.frm_main.title._add(getLang('TITLE::NEW_REMINDER',[out[i].title]),5);
	}
	
	this.items._fill(out);
};

_me.__handler = function (bOk){
	this._destruct();
	
	if (bOk){
		dataSet.remove('reminders');
		gui.frm_main.__RMN_get();
	}
};