/**
 * BASED on SWFUpload: http://www.swfupload.org, http://swfupload.googlecode.com
 * version: 2.2.0 2009-03-25
 **/
 
_me = obj_attach_swf.prototype;
function obj_attach_swf(){};

//Global instance for flash object lookup used by Flash obj.
var SWFUpload = {instances:{}};

/**
 * @date : 1.12.2009 15:36:59
 **/
_me.__constructor = function(sButtonValue){

	this.__idTable = [];
	this.__movieElement = null;
	this.__uploadQueue = {};

    this.__flashReady = false;
    this.__flashQueue = [];

	this._getAnchor('button').value = getLang(sButtonValue || 'ATTACHMENT::UPLOAD');

	this.__settings = {
				// Backend Settings
				upload_url: "server/upload.php",
				file_post_name: "file",
				post_params: {swf:true,sid:dataSet.get('main',['sid'])},

				// Flash Settings
				flash_url: "client/inc/swf/swfupload.swf",  //v2.2.0.1
				prevent_swf_caching: true,
				movieName: this._pathName+"swf",

				// File Upload Settings
				file_size_limit : "0",	// 102400 = 100MB
				file_types : "*.*",
				file_types_description : getLang('UPLOAD::ALL_FILES'),
				file_upload_limit : "0",
				file_queue_limit : "0",

				// Button Settings
				button_placeholder_id: this._getAnchor('file'),
				button_width: 70,
				button_height: 30,
				button_window_mode: "transparent",
				button_action: -110, //multi|single
				button_cursor: -2 //hand
			}

	if (document.location.protocol == 'https:' && currentBrowser().indexOf('MSIE')<0 && (GWOthers.getItem('LAYOUT_SETTINGS','ssl_swfatt') || 0)<1){
		var iport = GWOthers.getItem('GLOBAL_SETTINGS','http_port') || sPrimaryAccountHTTP;
		this.__settings.upload_url = 'http://'+ document.location.hostname + (iport==80?'':':'+iport) + document.location.pathname + 'server/upload.php';
	}

	this._add_destructor("__swf_destructor");

	this.__loadFlash();
};

obj_attach_swf.__ERRORS = {
	//QUEUE ERRORS
	'-100':'QUEUE_LIMIT_EXCEEDED',
	'-110':'FILE_EXCEEDS_SIZE_LIMIT',
	'-120':'ZERO_BYTE_FILE',
	'-130':'INVALID_FILETYPE',
	
	//UPLOAD ERROR
	'-200':'HTTP_ERROR',
	'-210':'MISSING_UPLOAD_URL',
	'-220':'IO_ERROR',
	'-230':'SECURITY_ERROR',
	'-240':'UPLOAD_LIMIT_EXCEEDED',
	'-250':'UPLOAD_FAILED',
	'-260':'SPECIFIED_FILE_ID_NOT_FOUND',
	'-270':'FILE_VALIDATION_FAILED',
	'-280':'FILE_CANCELLED',
	'-290':'UPLOAD_STOPPED'
};

// Private: loadFlash replaces the button_placeholder element with the flash movie.
_me.__loadFlash = function () {

	//Add to global instance
	SWFUpload.instances[this.__settings.movieName] = this;

	// Append the container and load the flash
	var tempParent = mkElement('div');
		tempParent.innerHTML = this.__getFlashHTML();	// Using innerHTML is non-standard but the only sensible way to dynamically add Flash in IE (and maybe other browsers)

	var targetElement = this._getAnchor('file');
		targetElement.parentNode.replaceChild(tempParent.firstChild, targetElement);

	this.__movieElement = this._getAnchor('swf');

	// Fix IE Flash/Form bug
	if (window[this.__settings.movieName] == undefined)
		window[this.__settings.movieName] = this.__movieElement;
};

// Private: getFlashHTML generates the object tag needed to embed the flash in to the document
_me.__getFlashHTML = function () {
	return	'<object id="'+ this.__settings.movieName +'" type="application/x-shockwave-flash" data="'+ this.__settings.flash_url +'" width="'+ this.__settings.button_width +'" height="'+ this.__settings.button_height +'" class="swfupload">'+
			'<param name="wmode" value="'+ this.__settings.button_window_mode +'" />'+
			'<param name="movie" value="'+ this.__settings.flash_url +'" />'+
			'<param name="quality" value="high" />'+
			'<param name="menu" value="false" />'+
			'<param name="base" value="'+document.getElementsByTagName('base')[0].href+'" />'+
			'<param name="allowScriptAccess" value="always" />'+
			'<param name="flashvars" value="' + this.__getFlashVars() + '" />'+
			'</object>';
};

// Private: getFlashVars builds the parameter string that will be passed
// to flash in the flashvars param.
_me.__getFlashVars = function () {
	// Build the parameter string
	return ["movieName="+ encodeURIComponent(this.__settings.movieName),
			"uploadURL="+ encodeURIComponent(this.__settings.upload_url),
			"useQueryString=false",
			"requeueOnError=false",
//			"httpSuccess=",
			"assumeSuccessTimeout=0",
			"params="+ encodeURIComponent(this.__buildParamString()),
			"filePostName="+ encodeURIComponent(this.__settings.file_post_name),
			"fileTypes="+ encodeURIComponent(this.__settings.file_types),
			"fileTypesDescription="+ encodeURIComponent(this.__settings.file_types_description),
			"fileSizeLimit="+ encodeURIComponent(this.__settings.file_size_limit),
			"fileUploadLimit="+ encodeURIComponent(this.__settings.file_upload_limit),
			"fileQueueLimit="+ encodeURIComponent(this.__settings.file_queue_limit),
			"debugEnabled=",
			"buttonWidth="+ encodeURIComponent(this.__settings.button_width),
			"buttonHeight="+ encodeURIComponent(this.__settings.button_height),
			"buttonText=",
			"buttonImageURL=",
			"buttonAction="+ encodeURIComponent(this.__settings.button_action),
			"buttonCursor="+ encodeURIComponent(this.__settings.button_cursor)
		].join("&amp;");
};

_me.__buildParamString = function () {
	var postParams = this.__settings.post_params;
	var paramStringPairs = [];

	if (typeof(postParams) === "object")
		for (var name in postParams)
			if (postParams.hasOwnProperty(name))
				paramStringPairs.push(encodeURIComponent(name.toString()) + "=" + encodeURIComponent(postParams[name]?postParams[name].toString():''));

	return paramStringPairs.join("&amp;");
};


// Private: unescapeFileParams is part of a workaround for a flash bug where objects passed through ExternalInterface cannot have
// properties that contain characters that are not valid for JavaScript identifiers. To work around this
// the Flash Component escapes the parameter names and we must unescape again before passing them along.
_me.__unescapeFilePostParams = function (file) {
	var reg = /[$]([0-9a-f]{4})/i;
	var unescapedPost = {};
	var uk;

	if (file != undefined) {
		for (var k in file.post) {
			if (file.post.hasOwnProperty(k)) {
				uk = k;
				var match;
				while ((match = reg.exec(uk)) !== null) {
					uk = uk.replace(match[0], String.fromCharCode(parseInt("0x" + match[1], 16)));
				}
				unescapedPost[uk] = file.post[k];
			}
		}

		file.post = unescapedPost;
	}

	return file;
};

// Private: callFlash handles function calls made to the Flash element.
// Calls are made with a setTimeout for some functions to work around
// bugs in the ExternalInterface library.
_me.__callFlash = function (functionName, argumentArray) {
	argumentArray = argumentArray || [];
	var returnValue, returnString;

	// Flash's method if calling ExternalInterface methods (code adapted from MooTools).
	try {
		returnString = this.__movieElement.CallFunction('<invoke name="' + functionName + '" returntype="javascript">' + __flash__argumentsToXML(argumentArray, 0) + '</invoke>');
		returnValue = eval(returnString);
	}
	catch (ex) {
		if (this.__flashReady && !this._destructed){
			if (functionName != 'TestExternalInterface' || currentBrowser().indexOf('MSIE')!=0)
				alert("SWFUpload call to " + functionName + " failed with args:\n"+ __flash__argumentsToXML(argumentArray, 0));
		}
		else
		//for case that flash is not ready yet
            this.__flashQueue.push([functionName,argumentArray]);
	}

	// Unescape file post param values
	if (returnValue != undefined && typeof returnValue.post === "object")
		returnValue = this.__unescapeFilePostParams(returnValue);

	return returnValue;
};


/////////////////////// PUBLIC METHODs ///////////////////////////

/******************************
 *	-- Flash control methods --
 *	Your UI should use these
 *	to operate SWFUpload
 *******************************/
   
// The optional parameter 'fileID' specifies the ID
_me._startUpload = function (fileID) {
	this.__callFlash("StartUpload", [fileID]);
};

// The fileID parameter may be the file ID or index.
// If you do not specify a fileID the current uploading file or first file in the queue is cancelled.
// If you do not want the uploadError event to trigger you can specify false for the triggerErrorEvent parameter.
_me._cancelUpload = function (fileID, triggerErrorEvent) {
	if (triggerErrorEvent !== false)
		triggerErrorEvent = true;

	this.__callFlash("CancelUpload", [fileID, triggerErrorEvent]);
};


/*************************
 * Settings methods
 *   These methods change the SWFUpload settings.
 *   SWFUpload settings should not be changed directly on the settings object
 *   since many of the settings need to be passed to Flash in order to take
 *   effect.
 *************************/

// Public: getStats gets the file statistics object.
_me._getStats = function () {
	return this.__callFlash("GetStats");
};

// Public: getFile retrieves a File object by ID or Index.  If the file is
// not found then 'null' is returned.
_me._getFile = function (fileID) {
	if (typeof(fileID) === "number")
		return this.__callFlash("GetFileByIndex", [fileID]);
	else
		return this.__callFlash("GetFile", [fileID]);
};

// Public: setUploadUrl changes the upload_url setting.
_me._setUploadURL = function (url) {
	this.__settings.upload_url = url.toString();
	this.__callFlash("SetUploadURL", [url]);
};

// Public: setPostParam changes the post_params setting
_me._setPostParam = function (name, value) {
	if (typeof value == 'undefined')
		delete this.__settings.post_params[name];
	else
		this.__settings.post_params[name] = value;
	
	this.__callFlash("SetPostParams", [this.__settings.post_params]);
};

/*
// Public: setFileQueueLimit changes the file_queue_limit setting
_me._setFileUploadLimit = function (fileUploadLimit) {
	this.__settings.file_upload_limit = fileUploadLimit;
	this.__callFlash("SetFileUploadLimit", [fileUploadLimit]);
};
*/
// Public: setFileQueueLimit changes the file_queue_limit setting
_me._setFileQueueLimit = function (fileQueueLimit) {
	this.__settings.file_queue_limit = fileQueueLimit;
	this.__callFlash("SetFileQueueLimit", [fileQueueLimit]);
};


// Public: setFilePostName changes the file_post_name setting
// Server support "file" only
/*
_me._setFilePostName = function (filePostName) {
	this.__settings.file_post_name = filePostName;
	this.__callFlash("SetFilePostName", [filePostName]);
};
*/

// Public: setButtonDimensions resizes the Flash Movie and button
_me._setButtonDimensions = function (width, height) {
	this.__settings.button_width = width;
	this.__settings.button_height = height;

	if (this.__movieElement != undefined) {
		this.__movieElement.style.width = width + "px";
		this.__movieElement.style.height = height + "px";
	}

	this.__callFlash("SetButtonDimensions", [width, height]);
};

// Public: setButtonDisabled disables/enables the button
_me._setButtonDisabled = function (isDisabled) {
	this.__settings.button_disabled = isDisabled;
	this.__callFlash("SetButtonDisabled", [isDisabled]);
};

// Public: setButtonAction sets the action that occurs when the button is clicked
// -100 - singe
// -110 - multi (default)
// -120 - START_UPLOAD
_me._setMultipleSelection = function (bMulti) {
	this.__settings.button_action = bMulti?-110:-100;
	this.__callFlash("SetButtonAction", [bMulti?-110:-100]);
};

///////////////////////////////////////////////

_me.__swf_destructor = function (){
	try {
		// Make sure Flash is done before we try to remove it
		this._cancelUpload(null, false);

		//remove from global instance
		SWFUpload.instances[this.__settings.movieName] = null;
		delete SWFUpload.instances[this.__settings.movieName];

		// Remove the SWFUpload DOM nodes
		var movieElement = this.__movieElement;

		if (movieElement && typeof(movieElement.CallFunction) === "unknown") { // We only want to do this in IE
			// Loop through all the movie's properties and remove all function references (DOM/JS IE 6/7 memory leak workaround)
			for (var i in movieElement) {
				try {
					if (typeof(movieElement[i]) === "function") {
						movieElement[i] = null;
					}
				} catch (ex1) {}
			}

			// Remove the Movie Element from the page
			try {
				movieElement.parentNode.removeChild(movieElement);
			} catch (ex) {}
		}

		// Remove IE form fix reference
		window[this.__settings.movieName] = null;

		this.__movieElement = null;
		this.__settings = null;

		return true;
	}
	catch (ex2) {
		return false;
	}
};

// Private: removes Flash added fuctions to the DOM node to prevent memory leaks in IE.
// This function is called by Flash each time the ExternalInterface functions are created.
_me.__cleanUp = function (movieElement) {
	// Pro-actively unhook all the Flash functions
	try {
        // We only want to do this in IE
		if (this.__movieElement && typeof(this.__movieElement.CallFunction) === "unknown") {
			//alert("Removing Flash functions hooks (this should only run in IE and should prevent memory leaks)");
			for (var key in this.__movieElement)
				try {
					if (typeof(this.__movieElement[key]) === "function") {
						this.__movieElement[key] = null;
					}
				}
				catch (ex) {}
		}
	}
	catch (ex1) {}

	// Fix Flashes own cleanup code so if the SWFMovie was removed from the page
	// it doesn't display errors.
	window["__flash__removeCallback"] = function (instance, name) {
		try {
			if (instance)
				instance[name] = null;
		}
		catch (flashEx) {}
	};
};
///////////////////////////// HARDCODED FUNCTIONS FROM SWFUPLOAD /////////////////////////////

// Private: Called by Flash to see if JS can call in to Flash (test if External Interface is working)
_me.testExternalInterface = function () {
	try {
		return this.__callFlash("TestExternalInterface");
	} catch (ex) {
		return false;
	}
};


// Private: This event is called by Flash when it has finished loading. Don't modify this.
// Use the swfupload_loaded_handler event setting to execute custom code when SWFUpload has loaded.

_me.flashReady = function () {
	// Check that the movie element is loaded correctly with its ExternalInterface methods defined
	if (!this.__movieElement) {
		alert("Flash called back ready but the flash movie can't be found.");
		return;
	}

	this.__cleanUp(this.__movieElement);
	
	this.__flashReady = true;

	// passe variables to flash
	while(this.__flashQueue.length)
		this.__callFlash.apply(this,this.__flashQueue.shift());

	//Resize Masking Flash over button
	var size = getSize(this._getAnchor('button'));
	this._setButtonDimensions(size.w,size.h);

};

// File Dialog was opened
_me.fileDialogStart = function () {};

// Add file to queue
_me.fileQueued = function (file) {
    if (this._onqueue){
		file = this.__unescapeFilePostParams(file);
		this._onqueue(file);
	}
};

	// Handle errors that occur when an attempt to queue a file fails.
	_me.fileQueueError = function (file, errorCode, message) {
		if (obj_attach_swf.__ERRORS[errorCode])
        	alert(getLang('UPLOAD::'+obj_attach_swf.__ERRORS[errorCode]));
		else
			alert("fileQueueError\n"+errorCode+"\n"+message);
	};

// File Dialog was closed
_me.fileDialogComplete = function (numFilesSelected, numFilesQueued, numFilesInQueue) {
	if (numFilesSelected>0)
        this._startUpload();
};

_me.uploadStart = function (file) {

	// UPLOADSTART event
    if (this._onuploadstart)
		this._onuploadstart();
			
	// zde se da otestovat file a vratit [FALSE]
	this.__callFlash("ReturnUploadStart", [true]);
};
/*
	QUEUED		 : -1,
	IN_PROGRESS	 : -2,
	ERROR		 : -3,
	COMPLETE	 : -4,
	CANCELLED	 : -5
*/
_me.uploadProgress = function (file, bytesComplete, bytesTotal) {
	file = this.__unescapeFilePostParams(file);

	if (this._onuploadprogress)
		this._onuploadprogress(file,bytesComplete, bytesTotal);
};

/*
	HTTP_ERROR				  		: -200,
	MISSING_UPLOAD_URL	      		: -210,
	IO_ERROR				  		: -220,
	SECURITY_ERROR			  		: -230,
	UPLOAD_LIMIT_EXCEEDED	  		: -240,
	UPLOAD_FAILED			  		: -250,
	SPECIFIED_FILE_ID_NOT_FOUND		: -260,
	FILE_VALIDATION_FAILED	  		: -270,
	FILE_CANCELLED			  		: -280,
	UPLOAD_STOPPED					: -290
*/
_me.uploadError = function (file, errorCode, message) {
	file = this.__unescapeFilePostParams(file);
	
    if (this._onqueueremove)
		this._onqueueremove(file);
			
	alert(obj_attach_swf.__ERRORS[errorCode]+(message?"\n"+message:''));
};

_me.uploadSuccess = function (file, serverData, responseReceived) {
	file = this.__unescapeFilePostParams(file);

	if (responseReceived && serverData)
		try{
            var aData = eval("("+serverData+")");

			this._setFolder(aData.folder);

			var aArg = {id:aData.id,folder:aData.folder,name:file.name,size:file.size};

		    if (this._onuploadsuccess)
				this._onuploadsuccess(aArg);
		}
		catch(r){
			setTimeout(function(){alert("server error: "+serverData);},0);
		}
};

_me.uploadComplete = function (file) {
	if (this._getStats().files_queued > 0)
        this._startUpload();
    else
	// UPLOADEND event
	if (this._onuploadend)
		this._onuploadend();
};

//////////////////// COMPATIBILITY ////////////////////////
_me._setFolder = function(sFolder){
	this._setPostParam ('folder',WMItems.__serverID(sFolder) || Math.rand());
};
_me._getFolder = function (){
	return this.__settings.post_params['folder'];
};