_me = obj_select_input.prototype;
function obj_select_input(){};

	_me.__constructor = function(){
		var me = this;
		/* options visibility */
        this.__sValue = '';

		this.__eInput  = this._getAnchor('input');
		this.__eInput = this.__eInput.form[this.__eInput.name];
        this.__eInput.setAttribute('autocomplete',"off");

		this.__eInput.onfocus = function(e){
			if (me.__hideTimeout) window.clearTimeout(me.__hideTimeout);
		};
		/*
		this.__eInput._value = function(v){
			if (Is.Defined(v))
			    this.value = v.toString().unescapeHTML();
			else
			    return this.value.toString().escapeHTML();
		};
		*/

        this.__eInput.onkeydown = function(e){
            var e = e || window.event;
			var elm = e.target || e.srcElement;
			
			/*
			switch(e.keyCode){
			//UP
			case 38:
			    break;
			//DN
			case 40:
			}
			*/
			
			return true;
		};

		/*
        this.__eInput.onsubmit = function(e){
            var e = e || window.event;
            if (me._onsubmit)
            	me._onsubmit(e);
		};
		*/

		this.__eInput.onkeyup = function(e){
			var key = -1;
			for(var i in me.__idTable)
				if (me.__idTable[i] == this.value)
					key = i;

			if (key != -1)
				me.__value(key);
			else
            	me.__value(this.value);
		};

		this.__eInput.onchange = function(e){
			if (typeof me.__idTable[me.__sValue] != 'undefined' && me.__idTable[me.__sValue] == this.value)
				return;

			if (me.__sValue != this.value)
				me._value(this.value);
		};


        this.__eInput.onblur = function(e){
			me.__hideTimeout = window.setTimeout('try{'+me._pathName + '.__hide();}catch(err){}',150);

			if (me._onblur)
				me._onblur();
		};

		this.__eButton.onblur = null;
        
        
		this.__eButton.onfocus = function(e){
			me._focus();
		};
		
		this.__eButton.onkeyup = function(e){
			var e = e || window.event;
			var elm = e.target || e.srcElement;

			if (me._onkeyup)
				return me._onkeyup(e);
		};

        this.__eButton.onkeydown = function(e){
			if(me.__disabled) return false;

			var e = e || window.event;
			var elm = e.target || e.srcElement;
			/*
			e.cancelBubble = true;
			if (e.stopPropagation) e.stopPropagation();
			*/

			//prepare ids
			if (e.keyCode == 38 || e.keyCode == 40){

				if (!me.__visibleOptions)
                    me.__show();
                    
				var before,myself,after, v = me.__sValue.toString();//me.__value();
				
				//If actual value is different (user specified) than available values in pulldown
				//then try to finde similar one
				if (!v.length){
					for (var i in me.__idTable){
						before = i.toString();
						if (typeof after == 'undefined')
						    after = i.toString();
					}

	                if (typeof after == 'undefined')
						return false;
				}
				else
				for (var i in me.__idTable)
					if  (i != v){
						if  (typeof myself == 'undefined')
							before = i;
						else{
							after = i;
							break;
						}
					}
					else
						myself = i;
			}

			switch(e.keyCode){
			//Up
			case 38:
					if (typeof before != 'undefined'){
						me.__value(before);
						if (!me.__visibleOptions)
	                        me.__show();
					}
                    return false;
			//Down
			case 40:
					if (typeof after != 'undefined'){
						me.__value(after);
						if (!me.__visibleOptions)
	                        me.__show();
					}

					return false;
			//Enter
			case 13:
					if (!me.__visibleOptions){
						if (me._onsubmit)
                        	me._onsubmit();

						return false;
                    }
			//Esc
			case 27:
					me.__hide();
					return false;
					break;
			case 9:
				e.cancelBubble = true;
				try{e.preventDefault();}catch(r){}
				try{e.stopPropagation();}catch(r){}
				
				if (e.shiftKey)
					me.__tabIndex_dock._tabIndexPrev(me);
				else
                    me.__tabIndex_dock._tabIndexNext(me);

				return false;
				
				break;
			default:
			    if (me._onkeydown)
			    	return me._onkeydown();
			}
		};
	};
	
	
	
	_me.__show = function(){

        if (this.__hideTimeout)
			window.clearTimeout(this.__hideTimeout);
			
		if (!this.__createOptionList())
		    return;

		this._focus();
		
		this.__visibleOptions = true;

		var pos = getSize(this._main);

		this.__eOptions.style.width = pos.w + 'px';
		this.__eOptions.style.top   = (pos.y+pos.h) + 'px';
		this.__eOptions.style.left 	= pos.x + 'px';

		this.__eOptions.style.display = 'block';

		if (count(this.__idTable)>10){
            this.__eOptions.style.overflow = 'auto';

            var size = 0;
			try{
            	size = getSize(this.__eOptions.getElementsByTagName('A')[0]).h*10;
			}
			catch(er){
				size = 153;
			}

			this.__eOptions.style.height = size +'px';
		}
		else{
            this.__eOptions.style.overflow = 'visible';
            this.__eOptions.style.height = 'auto';
		}

		this.__activate();
	};
	
	_me.__value = function(sData,bNoEvn) {

		if (typeof sData == 'undefined'){
			var inpv = this.__eInput.value;
			for (var i in this.__idTable)
				if (this.__idTable[i] === inpv)
				    return i;
				    
			return inpv;
		}
		
        if (this.__sValue === sData) return;

		if (typeof this.__idTable[sData] == 'undefined')
            this.__eInput.value = sData;
		else
            this.__eInput.value = this.__idTable[sData];

        this.__activate(sData);

		this.__sValue = sData;

		if (!bNoEvn){
			// onchange event
	        if(this._onchange) this._onchange(null);
		    this.__exeEvent('onchange',null,{"owner":this});
	    }
	};

	_me._value = function(sData,bNoEvn) {
		return this.__value(sData,bNoEvn);
	};

	_me.__activate = function(key){
		if (!this.__eOptions) return;

		if (this.__tempValue){
			var tmp = this.__eOptions.getElementsByTagName('A');
			for(var i in tmp)
				removecss(tmp[i],'active');

			this.__tempValue = '';
		}

		var elm;

		if (this.__sValue && (elm = document.getElementById(this._pathName+this.__sValue))){
			if (typeof key == 'undefined'){
				addcss(elm,'active');

				// scroll to value
				if (elm.offsetTop>this.__eOptions.scrollTop+this.__eOptions.clientHeight || elm.offsetTop<this.__eOptions.scrollTop)
					this.__eOptions.scrollTop = elm.offsetTop - (this.__eOptions.clientHeight/2);

				return;
			}
			else
				removecss(elm,'active');
		}

		if (typeof key != 'undefined' && (elm = document.getElementById(this._pathName+key))){
			addcss(elm,'active');

			// scroll to value
			if (elm.offsetTop<this.__eOptions.scrollTop)
				this.__eOptions.scrollTop = elm.offsetTop+1;
			else
			if (elm.offsetTop+elm.offsetHeight>this.__eOptions.clientHeight+this.__eOptions.scrollTop)
				this.__eOptions.scrollTop = elm.offsetTop+elm.offsetHeight - this.__eOptions.clientHeight-1;
		}
	};

//FOCUS
_me._getFocusElement = function (){
	return this.__eInput;
};

_me._focus = function (){
	var h,pos = getSize(this.__eInput);

	if (window.innerHeight)
	    h = window.innerHeight;
	else
	if (window.document.body)
		h = window.document.body.clientHeight;

	if (pos.y+20<h){
		this.__eInput.focus();
		return true;
	}
	else
	    return false;
};