_me = obj_upload_edit.prototype;
function obj_upload_edit(){};

_me.__constructor = function(sButtonValue){
	var me = this;
	var list = this._getAnchor('list');
	
	this.__idtable = [];
	
	list.onclick = function (e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;
		//elm = elm.parentNode;
		if (elm.tagName != 'A') return false;

        if (e.type == 'contextmenu' && me._oncontext)
			me._oncontext(e, elm.id.substr(me._pathName.length+1));
		else
		if (me._onclick)
			me._onclick(elm.id.substr(me._pathName.length+1));
			
		return false;
	};
	list.oncontextmenu = list.onclick;
	
	////// FILE //////
	this.file._onuploadsuccess = function(file){
		me._add(file);
	};
	this.file._onuploadstart = function (){
		if (me._onuploadstart)
			me._onuploadstart();
	};
	this.file._onuploadend = function (){
		if (me._onuploadend)
			me._onuploadend();
	};
};

_me._add = function(aArg){
	aArg.folder = this.file._getFolder();
	this.__idtable.push(aArg);

	var id = this.__idtable.length-1;

	if (this._onuploadsuccess)
		this._onuploadsuccess(aArg, id);

	//Add gui element
	this._addGuiElement(aArg, id);
};

/**
 * PUBLIC                                OK;
 **/
_me._addGuiElement = function (aArg,id){
	this._getAnchor('list').appendChild(mkElement('a',{href:"",innerHTML:aArg.name + (aArg.size?' ('+parseFileSize(aArg.size)+');':';'),id:this._pathName+'/'+id}));
};
/**
 * PUBLIC                                OK;
 **/
_me._value = function(v){
	if (typeof v == 'undefined'){
		var out = [];
		for (var i in this.__idtable)
			if (this.__idtable[i]['class'] == 'attachment' && !this.__idtable[i]['fullpath']){
				if (this.__idtable[i]['removed'])
				    out.push({uid:this.__idtable[i].id});
			}
			else
			if (!this.__idtable[i]['removed']){
				out.push({values:{'class':this.__idtable[i]['class'] || 'file',description:this.__idtable[i]['name'],size:this.__idtable[i]['size'],fullpath:this.__idtable[i]['fullpath'] || (this.__idtable[i]['folder']+"/"+this.__idtable[i]['id'])}});
			}

		return out;
	}
	else{
		if (v.path)
	        this.file._setFolder(v.path);
	    if (v.values)
			for(var i in v.values)
            	this._add(v.values[i]);
	}
};

_me._remove = function (id){
	if (typeof id == 'undefined'){
	    for(var i in this.__idtable)
	        this._remove(i);
	}
	else
	if (this.__idtable[id] && !this.__idtable[id].removed){
		this.__idtable[id].removed = true;

		var elm = document.getElementById(this._pathName+'/'+id);
		if (elm)
		    elm.parentNode.removeChild(elm);
	}
	
	if (this._onchange)
		this._onchange();
};

/**
 * PUBLIC
 **/
_me._oncontext = function(e,id) {
	// PREDELAT VOLANI FUNKCE
	var aMenu = [{"title":'ATTACHMENT::REMOVE','arg':[this,'_remove',[id]]},
				 {"title":'ATTACHMENT::REMOVE_ALL','arg':[this,'_remove',[]]}];

	var cmenu = gui._create("cmenu","obj_context",'','',this);
		cmenu._fill(aMenu);
		cmenu._place(e.clientX,e.clientY);
};

_me._onclick = function(id) {

	var sClass = this.__idtable[id]['class'] || 'file';
    var sFullPath = '';

	switch (sClass) {
		case 'file': sFullPath = this.file._getFolder()+'/'+this.__idtable[id]['id']; break;
		case 'attachment': sFullPath = this.__idtable[id]['fullpath'] || (this.__idtable[id]['folder']+'/'+this.__idtable[id]['id']); break;
	}

	if (sFullPath) {
		var aUrl = {'sid': dataSet.get('main', ['sid']), 'class': sClass, 'fullpath': sFullPath};
        downloadItem(buildURL(aUrl));
	}
};

_me._getName = function(id) {
    id = typeof id == 'undefined'?this.__idtable.length-1:id;
	return this.__idtable[id]?this.__idtable[id].name:'';
};
_me._getSize = function(id) {
    id = typeof id == 'undefined'?this.__idtable.length-1:id;
	return this.__idtable[id]?this.__idtable[id].size:0;
};