#!/bin/bash
#
# IceWarp Server
# Copyright (c) 2008-2010 IceWarp Ltd. All rights reserved.
#
# http://www.icewarp.com
#
# file: submitconf.sh - wizard menu script
#

if [ "x${IWS_INSTALL_DIR}" == "x" ]; then
    echo "This script needs environemnt variable IWS_INSTALL_DIR"
    exit 1
fi

if [ "x${FUNCTIONS_INCLUDED}" == "x" ]; then
    source "${IWS_INSTALL_DIR}/scripts/inc/functions.sh"
fi

submitconf()
{
    good ""
    ask_with_confirmation "${BAD}Overwrite current configuration with system.conf values?${NORMAL}" "N" "y"
    if [ $? -eq 2 ]; then
        run_cmd_log "${IWS_INSTALL_DIR}/tool.sh" "FILE" "BATCH" "config/system.conf" "modify system c." > /dev/null
        if [ $? -eq 0 ]; then
	    good "Configuration submitted"
	else
	    bad "Configuation submit problem!"
	fi
    else
        warn "User cancelled"
    fi
    return 0
}

submitconf
exit 0
