_me = frm_contact.prototype;
function frm_contact(){};

_me.__constructor = function() {
	this._defaultSize(-1,-1,700,460);

	this._draw('frm_contact', 'main', {ticket_url:this._aValues.TICKET?true:false});
	
	this.__initForm('CONTACT::CONTACT');
};

_me.__print = function(aValues){

	if (aValues.LOCATIONS)
		for (var i in aValues.LOCATIONS){
			if (aValues.LOCATIONS[i].values.LCTTYPE == 'H'){
				aValues.values = objConcat (aValues.values,aValues.LOCATIONS[i].values);
				if (aValues.LOCATIONS[i].PHONES){
                    aValues.values.PHONES = [];
					for (var j in aValues.LOCATIONS[i].PHONES)
						aValues.values.PHONES.push({PHNTYPE:getLang('PHONE::'+aValues.LOCATIONS[i].PHONES[j].values.PHNTYPE),PHNNUMBER: aValues.LOCATIONS[i].PHONES[j].values.PHNNUMBER});
				}
			}
			else
			if (aValues.LOCATIONS[i].values.LCTTYPE == 'B'){
			    aValues.values.LCTSTREET = aValues.LOCATIONS[i].values.LCTSTREET;
			    aValues.values.LCTCITY = aValues.LOCATIONS[i].values.LCTCITY;
			    aValues.values.LCTSTATE = aValues.LOCATIONS[i].values.LCTSTATE;
			    aValues.values.LCTCOUNTRY = aValues.LOCATIONS[i].values.LCTCOUNTRY;
			    aValues.values.LCTZIP = aValues.LOCATIONS[i].values.LCTZIP;
			}
		}

	aValues = aValues.values;

	if (!gui.print)
		gui._create('print','frm_print');

	gui.print._template('print_contact',aValues);
};

_me.__showAvatar = function(sType,sPath) {
	document.getElementById(this.maintab.tab1._pathName+'avatar_image').style.backgroundImage =  'url("server/download.php?sid='+dataSet.get("main",['sid'])+'&class='+sType+'&fullpath='+sPath+'")';
};

_me.__loadItems = function() {
	if (!this.maintab) return;
	var me = this;
	var oTabs = this.maintab;

	// parsing Locations
	if (Is.Defined(this._aValues['LOCATIONS'])) {
		var aLocation;
		var aLocations = this._aValues['LOCATIONS'];

		for (var i in aLocations) {
			aLocation = aLocations[i];

			switch (aLocation['values']['LCTTYPE']) {
				case 'H': this._sHomeLocation = aLocation; break;
				case 'O': this._sOtherLocation = aLocation; break;
				case 'B': this._sBusinessLocation = aLocation; break;
			}
			if (aLocation['values']['LCT_ID'])
				aLocation['uid'] = i;
		}
	}

	// TAB1
	loadDataIntoForm(oTabs.tab1,this._aValues);

	//Copy contact name into window title
	oTabs.tab1.ITMCLASSIFYAS._onkeyup = function(){
		var sTitle = this._value();
		if (sTitle){
			if (sTitle.length>32)
			    sTitle = sTitle.substr(0,32)+'...';

			me._title(sTitle,true);
		}
		else
		    me._title('CONTACT::CONTACT');
	};
	oTabs.tab1.ITMCLASSIFYAS._onkeyup();

	//Avatar Button
    oTabs.tab1.X_AVATAR._onuploadend = function(arg){
        arg = arg[arg.length-1];
		if (arg.folder && arg.id)
			me.__showAvatar('file', arg.folder+'/'+arg.id);
	};

    //Avatar Image
	if (Is.Defined(me._aValues['ATTACHMENTS']))
		for(var i in me._aValues['ATTACHMENTS'])
			if (me._aValues['ATTACHMENTS'][i].values.ATTTYPE == 'P'){
                this.__showAvatar('attachment', me._sAccountID+'/'+me._sFolderID+'/'+WMItems.__serverID(me._sItemID)+'/'+i);
                break;
			}


	if (Is.Defined(this._sHomeLocation)) {
		if (Is.Defined(this._sHomeLocation['values']['LCTEMAIL1']))
			oTabs.tab1.X_EMAIL1._value(this._sHomeLocation['values']['LCTEMAIL1']);
		if (Is.Defined(this._sHomeLocation['values']['LCTEMAIL2']))
			oTabs.tab1.X_EMAIL2._value(this._sHomeLocation['values']['LCTEMAIL2']);
		if (Is.Defined(this._sHomeLocation['values']['LCTEMAIL3']))
			oTabs.tab1.X_EMAIL3._value(this._sHomeLocation['values']['LCTEMAIL3']);

		if (Is.Defined(this._sHomeLocation['values']['LCTIM']))
			oTabs.tab1.X_IM1._value(this._sHomeLocation['values']['LCTIM']);

		var j = 1;

		for (var nPhone in this._sHomeLocation['PHONES']) {
			oTabs.tab1['X_PHONE'+j]._value(this._sHomeLocation['PHONES'][nPhone]);
			if (j++ >= 4) break;
		}
	}
	//Default Phone type values
	else{
		oTabs.tab1['X_PHONE1']._value({values:{PHNTYPE:'D'}});
		oTabs.tab1['X_PHONE2']._value({values:{PHNTYPE:'A'}});
		oTabs.tab1['X_PHONE3']._value({values:{PHNTYPE:'G'}});
		oTabs.tab1['X_PHONE4']._value({values:{PHNTYPE:'L'}});
	}

	if (!this._aValues['ITM_ID'])
		oTabs.tab1.ITMSHARETYPE._value(GWOthers.getItem('DEFAULT_CALENDAR_SETTINGS','contact_sharing'));

    oTabs.tab1._onactive = function(){
		this.ITMCLASSIFYAS._focus();
	};

	// TAB2
	oTabs.tab2._onactive = function (bFirstTime) {
		if (bFirstTime) {
			loadDataIntoForm(this,me._aValues);
			if (Is.Defined(me._sHomeLocation)) {
				this.X_HOME_ADDRESS._value(me._sHomeLocation);
				if (Is.Defined(me._sHomeLocation['values']['LCTWEBPAGE']))
					this.X_HOMEPAGE._value(me._sHomeLocation['values']['LCTWEBPAGE']);
			}
			if (Is.Defined(me._sOtherLocation)){
				this.X_OTHER_ADDRESS._value(me._sOtherLocation);
				if (Is.Defined(me._sOtherLocation['values']['LCTWEBPAGE']))
					this.X_HOMEPAGE2._value(me._sOtherLocation['values']['LCTWEBPAGE']);
			}
		}
		
		this.X_HOME_ADDRESS._focus();
	}
	
	// TAB3
	oTabs.tab3._onactive = function (bFirstTime) {
		if (bFirstTime) {
			loadDataIntoForm(this,me._aValues);
			if (Is.Defined(me._sBusinessLocation)) {
				this.X_OFFICE_ADDRESS._value(me._sBusinessLocation);
				if (Is.Defined(me._sBusinessLocation['values']['LCTWEBPAGE']))
					this.X_WEB._value(me._sBusinessLocation['values']['LCTWEBPAGE']);
			}
		}

		this.ITMCOMPANY._focus();
	}			
		
	// TAB4
	oTabs.tab4._onactive = function (bFirstTime) {
		if (bFirstTime)
			loadDataIntoForm(this,me._aValues);
			
		this.ITMDESCRIPTION._focus();
	}
	
	// TAB5
    if (oTabs.tab5)
	oTabs.tab5._onactive = function (bFirstTime) {
		if (bFirstTime){
			if (me._aValues['ATTACHMENTS']){
				var out = [];
				for (var i in me._aValues['ATTACHMENTS'])
					out.push({'name': me._aValues['ATTACHMENTS'][i]['values']['ATTDESC'], 'class': me._aValues['ATTACHMENTS'][i]['values']['ATTTYPE'], 'id': i, 'fullpath': me._aValues.fullpath, 'size': me._aValues['ATTACHMENTS'][i]['values']['ATTSIZE']});

				if (me._aValues.fullpath)
					this.X_ATTACHMENTS._value({'values': out});
				else
					this.X_ATTACHMENTS._value({'path': me._sAccountID+'/'+me._sFolderID+'/'+WMItems.__serverID(me._sItemID), 'values': out});
			}
			else
			if (me._aValues['PUSH_ATTACHMENTS'])
		        this.X_ATTACHMENTS._value({path:me._aValues['PUSH_ATTACHMENTS'][0]['fullpath'].substr(0,me._aValues['PUSH_ATTACHMENTS'][0]['fullpath'].lastIndexOf('/')),
											values:[{
												'name': me._aValues['PUSH_ATTACHMENTS'][0]['title'],
												'id': me._aValues['PUSH_ATTACHMENTS'][0]['id'],
												'size': me._aValues['PUSH_ATTACHMENTS'][0]['size'],
												'class': me._aValues['PUSH_ATTACHMENTS'][0]['embedded'] ? 'item' : 'itemlink',
												'fullpath': me._aValues['PUSH_ATTACHMENTS'][0]['fullpath']
											}]});
		}
	}

	// TAB6
	oTabs.tab6._onactive = function (bFirstTime) {
        if (bFirstTime && Is.Defined(me._aValues['CERTIFICATES'])){

			var	tmp,aCerts = [];
			for(var i in me._aValues['CERTIFICATES']){
			    tmp = XMLTools.Str2Arr(me._aValues['CERTIFICATES'][i].values.INFO).INFO[0];
				aCerts.push({'id':i,
							'name':tmp.SUBJECT[0].CN[0].VALUE,
							'class':'attachment',
							//'email':tmp.SUBJECT[0].EMAILADDRESS[0].VALUE,
							'expires':tmp.VALIDTO[0].VALUE,
							'serial':tmp.SERIALNUMBER?tmp.SERIALNUMBER[0].VALUE:'',
							'data':tmp});
			}

			this.X_CERT._value({'path':me._sAccountID+'/'+me._sFolderID+'/'+me._sItemID, 'values':aCerts});
		}
	}
	
	if (this.maintab['public'])
		this.maintab['public']._onactive = function (bFirstTime){
			if (bFirstTime){
				this.X_TICKET._onclick = function(){
		        	this._setRange(0,this._value().length);
				};
				this.X_TICKET._readonly(true);
				this.X_TICKET._value(me._aValues.TICKET);
			}
		};

	if (me._aValues['PUSH_ATTACHMENTS'] && this.maintab.tab5)
		this.maintab.tab5._active();
};

_me.__saveItems = function(aValues) {

	//autofill classify as
	if (!aValues.values.ITMCLASSIFYAS){
        aValues.values.ITMCLASSIFYAS  = aValues.values.ITMSURNAME || '';
		aValues.values.ITMCLASSIFYAS += (aValues.values.ITMCLASSIFYAS?' ':'') + (aValues.values.ITMFIRSTNAME || '');
        if (!aValues.values.ITMCLASSIFYAS && aValues.values.ITMNICKNAME)
            aValues.values.ITMCLASSIFYAS = aValues.values.ITMNICKNAME;
    }

	var tab1 = this.maintab.tab1;
	var tab2 = this.maintab.tab2;
	var tab3 = this.maintab.tab3;
	var tab4 = this.maintab.tab4;
	var tab5 = this.maintab.tab5;
	var tab6 = this.maintab.tab6;

	var aHome;
	var aOther;
	var aBusiness;

	if (Is.Defined(tab2.X_HOME_ADDRESS)) {
		aHome = tab2.X_HOME_ADDRESS._value();
		aHome['values']['LCTWEBPAGE'] = tab2.X_HOMEPAGE._value();

		aOther = tab2.X_OTHER_ADDRESS._value();
		aOther['values']['LCTWEBPAGE'] = tab2.X_HOMEPAGE2._value();
	}
	else {
		if (Is.Defined(this._sHomeLocation))
			aHome = this._sHomeLocation;
		else
			aHome = {'values':{}};
			
		if (Is.Defined(this._sOtherLocation))
			aOther = this._sOtherLocation;
		else
			aOther = {'values':{}};
	}
	
	if (Is.Defined(tab3.X_OFFICE_ADDRESS)) {
		aBusiness = tab3.X_OFFICE_ADDRESS._value();
		aBusiness['values']['LCTWEBPAGE'] = tab3.X_WEB._value();
	}
	else{
		if (Is.Defined(this._sBusinessLocation))
			aBusiness = this._sBusinessLocation;
		else
			aBusiness = {'values':{}};
	}
	
	aHome['values']['LCTEMAIL1'] = tab1.X_EMAIL1._value();
	aHome['values']['LCTEMAIL2'] = tab1.X_EMAIL2._value();
	aHome['values']['LCTEMAIL3'] = tab1.X_EMAIL3._value();
	aHome['values']['LCTIM'] = tab1.X_IM1._value();

	var aPhones = [];
	var aPhone,aKeys = [];
	if (!Is.Empty(aPhone = tab1['X_PHONE1']._value())) aPhones.push(aPhone);
	if (!Is.Empty(aPhone = tab1['X_PHONE2']._value())) aPhones.push(aPhone);
	if (!Is.Empty(aPhone = tab1['X_PHONE3']._value())) aPhones.push(aPhone);
	if (!Is.Empty(aPhone = tab1['X_PHONE4']._value())) aPhones.push(aPhone);
	if (!Is.Empty(aPhones)){
		aHome['PHONES'] = aPhones;
		for(var k in aPhones)
		    aKeys.push(k);
	}

	var aLocations = [], bIsHome = false;
	if (!isFormEmpty(aHome)) {
		aHome['values']['LCTTYPE'] = 'H';
		aLocations.push(aHome);
		bIsHome = true;
	}

	if (!isFormEmpty(aBusiness)) {
		if (aHome['PHONES'] && aBusiness['PHONES']){
			var k = 0;
			for(var i in aBusiness['PHONES']){
                if (aBusiness['PHONES'][i].values.PHN_ID)
                	aBusiness['PHONES'][i].uid = aBusiness['PHONES'][i].values.PHN_ID;

				if (aKeys.length>k && aHome['PHONES'][aKeys[k]].values){
					aBusiness['PHONES'][i].values.PHNTYPE = aHome['PHONES'][aKeys[k]].values.PHNTYPE;
                    aBusiness['PHONES'][i].values.PHNNUMBER = aHome['PHONES'][aKeys[k]].values.PHNNUMBER;
                    aBusiness['PHONES'][i].values.PHNDESCRIPTION = aHome['PHONES'][aKeys[k]].values.PHNDESCRIPTION;
				}
				else
				if (aBusiness['PHONES'][i].values)
					delete aBusiness['PHONES'][i].values;

				k++;
			}
		}
		else
		    delete aBusiness['PHONES'];

		// add location
		aBusiness['values']['LCTTYPE'] = 'B';
		aLocations.push(aBusiness);
	}

	if (!isFormEmpty(aOther)) {
		if (aHome['PHONES'] && aOther['PHONES']){
			var k = 0;
			for(var i in aOther['PHONES']){

				if (aOther['PHONES'][i].values.PHN_ID)
                	aOther['PHONES'][i].uid = aOther['PHONES'][i].values.PHN_ID;

				if (aKeys.length>k && aHome['PHONES'][aKeys[k]].values){
					aOther['PHONES'][i].values.PHNTYPE = aHome['PHONES'][aKeys[k]].values.PHNTYPE;
                    aOther['PHONES'][i].values.PHNNUMBER = aHome['PHONES'][aKeys[k]].values.PHNNUMBER;
                    aOther['PHONES'][i].values.PHNDESCRIPTION = aHome['PHONES'][aKeys[k]].values.PHNDESCRIPTION;
				}
				else
				if (aOther['PHONES'][i].values)
					delete aOther['PHONES'][i].values;

				k++;
			}
		}
		else
		    delete aOther['PHONES'];
		    
		// add location
		aOther['values']['LCTTYPE'] = 'O';
		aLocations.push(aOther);
	}

	if (aLocations.length){

		// add HOME location if doesnt exist
		if (!bIsHome)
			aLocations.push({values:{LCTTYPE:'H'}});

		aValues['LOCATIONS'] = aLocations;
	}
	
	//Attachments
	var aAttachments;
	if (tab5 && tab5.X_ATTACHMENTS && !Is.Empty(aAttachments = tab5.X_ATTACHMENTS._value()))
		aValues['ATTACHMENTS'] = aAttachments;

	//Avatar
	if (tab1.X_AVATAR && !Is.Empty(aAttachments = tab1.X_AVATAR._value()) && aAttachments.values.length){

		if (!aValues['ATTACHMENTS'])
			aValues['ATTACHMENTS'] = [];
			
		//remove existing avatar
		for (var i in this._aValues['ATTACHMENTS'])
			if (this._aValues['ATTACHMENTS'][i].values.ATTTYPE == 'P'){
                aValues['ATTACHMENTS'].push({uid:i});
				break;
			}

		//append avatar
        aAttachments = aAttachments.values[aAttachments.values.length-1];
		aValues['ATTACHMENTS'].push({values:{"class":'image',description:aAttachments.name,fullpath:aAttachments.folder +'/'+ aAttachments.id}});
	}

	//Certificates
	var v;
	if (tab6.X_CERT && !Is.Empty(v = tab6.X_CERT._value()) && count(v)>0){
		aValues['CERTIFICATES'] = [];
		var out = [], tmp;
		for(var i in v){
            if (v[i].uid)
               aValues['CERTIFICATES'].push(v[i]);
            else
			if (v[i].fullpath){
				tmp = {'values':{'FILE':v[i].fullpath}};
				if (v[i].passphrase)
					tmp.values.PASSPHRASE = v[i].passphrase;

				aValues['CERTIFICATES'].push(tmp);
			}
		}
	}
};