_me = frm_event.prototype;
function frm_event(){};

_me.__constructor = function() {
	this._defaultSize(-1,-1,700,520);
	
	var aData = {};
	if (this._aValues.EVNCLASS == 'O')
       	aData.noRepeat = true;

	if (this._aValues.TICKET)
        aData.ticket_url = true;

	this._draw('frm_event', 'main', aData);
	
	//Fill EVNLOCATION on demand
	this.maintab.tab1.EVNLOCATION._oncreateOptionList = function(){
		if (this.___init)
		    return;

        var resources_path = dataSet.get('main',['resources_path']);
        if (resources_path){
			var aItemsInfo = {
					aid:sPrimaryAccount,
					fid:resources_path.substr(sPrimaryAccount.length+1),
					filter:{
						order_by:'ITMCLASSIFYAS asc',
					    sql: "(ITMCATEGORY LIKE 'Room')"
					},
					values:[
						'ITMCLASSIFYAS',
						'LCTEMAIL1'
						]
				};

			var out = {},tmp = WMItems.list(aItemsInfo);
			for (var i in tmp)
				for (var j in tmp[i]){
					delete tmp[i][j]['/'];
					delete tmp[i][j]['#'];
					delete tmp[i][j]['$'];

					for (var k in tmp[i][j])
					    out[tmp[i][j][k].ITMCLASSIFYAS || tmp[i][j][k].LCTEMAIL1] = tmp[i][j][k].ITMCLASSIFYAS || tmp[i][j][k].LCTEMAIL1;
				}

			this.___init = true;

			this._fill(out);
		}
	};
    
	//INIT FORM
	this.__initForm('EVENT::EVENT');
};

_me.__print = function(aValues){
	aValues = aValues.values;
	if (aValues.EVNSTARTDATE>0){
        var t = new Date();
		if (aValues.EVNSTARTTIME>0){
			t.setGWTime(aValues.EVNSTARTDATE,aValues.EVNSTARTTIME);
			aValues.COUNT_DATE = t.toWMString();
		}
		else{
			t.setGWTime(aValues.EVNSTARTDATE,0);
			aValues.COUNT_DATE = t.toWMString(true);
		}

		if (aValues.EVNENDTIME>0){
			t.setGWTime(aValues.EVNENDDATE,aValues.EVNENDTIME);
            aValues.COUNT_DATE += ' - ' + t.toWMString();
        }
        else{
			t.setGWTime(aValues.EVNENDDATE,0);
            aValues.COUNT_DATE += ' - ' + t.toWMString(true);
		}
	}
	else
    	aValues.COUNT_DATE = '';
            	
	if (!gui.print)
		gui._create('print','frm_print');
		
	gui.print._template('print_event',aValues);
};

_me.__loadItems = function() {
	var me = this;
	
	// TAB1
	var tab1 = this.maintab.tab1;
	tab1.X_TIMEINTERVAL._value(this._aValues);

	loadDataIntoForm(tab1,this._aValues);

 	if (!this._aValues['EVN_ID']) {
		this.maintab.tab1.X_EVNFLAGS._value(GWOthers.getItem('DEFAULT_CALENDAR_SETTINGS','event_show_as'));
		this.maintab.tab1.EVNSHARETYPE._value(GWOthers.getItem('DEFAULT_CALENDAR_SETTINGS','event_sharing'));
	}
	else{
		//set reminder
		this.maintab.tab1.X_REMINDERS._value(this._aValues['REMINDERS'] || '');

		var tmp = 'S',
			flg = this._aValues.EVNFLAGS?this._aValues.EVNFLAGS*1:0;

		if ((flg & 16) == 16)
			tmp = 'O';
		else
		if ((flg & 4) == 4)
			tmp = 'F';
		else
		if ((flg & 8) == 8)
			tmp = 'T';

		this.maintab.tab1.X_EVNFLAGS._value(tmp);
	}
	
	//Copy contact name into window title
	tab1.EVNTITLE._onkeyup = function(){
		var sTitle = this._value();
		if (sTitle){
			if (sTitle.length>32)
			    sTitle = sTitle.substr(0,32)+'...';

			me._title(sTitle,true);
		}
		else
			me._title('EVENT::EVENT');
	};
	tab1.EVNTITLE._onkeyup();

	// TAB2 (recurrence)
	if (this.maintab.tab2)
	this.maintab.tab2._onactive = function (bFirstTime) {
		if (bFirstTime) {
			var recurrence = shiftObject(me._aValues['RECURRENCES']);
			if (recurrence != null)
				this.X_REPEATING._value(recurrence);

			if (Is.Defined(me._aValues['EVNSTARTDATE'])) {
				var rawDate = parseJulianDate(me._aValues['EVNSTARTDATE']); 
				var date = new Date(rawDate.year, rawDate.month-1, rawDate.day);
				this.X_REPEATING._setDate(date);
			}
		}
	}

	// TAB3 (schedule)
	this.maintab.tab3._onactive = function (bFirstTime) {
		if (bFirstTime){

			var sOwner = '';
		    if(!(sOwner = me._aValues.EVNORGANIZER)){
				var tmpf = Path.split(me._sFolderID)[0];
			    if (dataSet.get('folders',[me._sAccountID,tmpf,'TYPE'])=='A')
					sOwner = tmpf;
				else
				    sOwner = me._sAccountID;
			}
			
			this._create('X_SCHEDULE','obj_schedule','','',sOwner,true,me._aValues['EVN_ID']);
			
			if (Is.Defined(me._aValues['CONTACTS']))
				this.X_SCHEDULE._attendees(me._aValues['CONTACTS']);

			if (!me._aValues['EVN_ID'] || me._aValues['EVNFLAGS']&1)
				this.X_SCHEDULE.X_TIMETABLE.invitation._value(1);
			else
			if (me._aValues['EVNFLAGS']&2)
				this.X_SCHEDULE.X_TIMETABLE.invitation._disabled(true);
		}

		this.X_SCHEDULE._sync(me.maintab.tab1.X_TIMEINTERVAL);
	}

	// TAB5 (attachments)
	if (this.maintab.tab5)
	this.maintab.tab5._onactive = function (bFirstTime) {
		if (bFirstTime){
			if (me._aValues['ATTACHMENTS']){
				var out = [];
				for (var i in me._aValues['ATTACHMENTS'])
					out.push({'name': me._aValues['ATTACHMENTS'][i]['values']['ATTDESC'], 'class': me._aValues['ATTACHMENTS'][i]['values']['ATTTYPE'], 'id': i, 'fullpath': me._aValues.fullpath, 'size': me._aValues['ATTACHMENTS'][i]['values']['ATTSIZE']});

				if (me._aValues.fullpath)
					this.X_ATTACHMENTS._value({'values': out});
				else
					this.X_ATTACHMENTS._value({'path': me._sAccountID+'/'+me._sFolderID+'/'+WMItems.__serverID(me._sItemID), 'values': out});
			}
			else
			if (me._aValues['PUSH_ATTACHMENTS'])
				this.X_ATTACHMENTS._value({path:me._aValues['PUSH_ATTACHMENTS'][0]['fullpath'].substr(0,me._aValues['PUSH_ATTACHMENTS'][0]['fullpath'].lastIndexOf('/')),
											values:[{
												'name': me._aValues['PUSH_ATTACHMENTS'][0]['title'],
												'id': me._aValues['PUSH_ATTACHMENTS'][0]['id'],
												'size': me._aValues['PUSH_ATTACHMENTS'][0]['size'],
												'class': me._aValues['PUSH_ATTACHMENTS'][0]['embedded'] ? 'item' : 'itemlink',
												'fullpath': me._aValues['PUSH_ATTACHMENTS'][0]['fullpath']
											}]});
		}
	}
	
	if (this.maintab['public'])
	    this.maintab['public']._onactive = function (bFirstTime){
			if (bFirstTime){
				this.X_TICKET._onclick = function(){
		        	this._setRange(0,this._value().length);
				};
				this.X_TICKET._readonly(true);
				this.X_TICKET._value(me._aValues.TICKET);
			}
		};

	if (me._aValues['PUSH_ATTACHMENTS'] && this.maintab.tab5)
		this.maintab.tab5._active();
};

_me.__saveItems = function(aValues) {

	// Show As
	if (this._aValues.EVNFLAGS)
		aValues['values'].EVNFLAGS = this._aValues.EVNFLAGS & ~ (4 | 8 | 16);
	else
		aValues['values'].EVNFLAGS = 0;

	var tmp = {F:4,T:8,O:16,S:0};
	aValues['values'].EVNFLAGS |= (aValues['values'].EVNFLAGS || 0) | tmp[this.maintab.tab1.X_EVNFLAGS._value()];

	// TAB1
	aValues['values'] = arrConcat(aValues['values'], this.maintab.tab1.X_TIMEINTERVAL._value());

	if (!Is.Empty(addon = this.maintab.tab1.X_REMINDERS._value()))
		aValues['REMINDERS'] = addon;

	// TAB2
	if (this.maintab.tab2 && this.maintab.tab2.X_REPEATING && !Is.Empty(addon = this.maintab.tab2.X_REPEATING._value()))
		aValues['RECURRENCES'] = [addon];

	// TAB3
	if (this.maintab.tab3.X_SCHEDULE){
		if (!Is.Empty(addon = this.maintab.tab3.X_SCHEDULE._attendees()))
			aValues['CONTACTS'] = addon;

		if (!this.maintab.tab3.X_SCHEDULE.X_TIMETABLE.invitation._disabled())
			aValues['values'].EVNFLAGS = this.maintab.tab3.X_SCHEDULE.X_TIMETABLE.invitation._value()?(aValues['values'].EVNFLAGS | 1):(aValues['values'].EVNFLAGS & ~1);
	}

	// TAB5
	if (this.maintab.tab5 && this.maintab.tab5.X_ATTACHMENTS && !Is.Empty(addon = this.maintab.tab5.X_ATTACHMENTS._value()))
		aValues['ATTACHMENTS'] = addon;
};