_me = frm_note.prototype;
function frm_note(){};

_me.__constructor = function() {

	this._defaultSize(-1,-1,550,450);
	
	this._draw('frm_note', 'main',{ticket_url:(this._aValues.TICKET?true:false)});
	this.__initForm('NOTE::NOTE');

	//set nowrap mode for obj_text
	this.maintab.tab1.NOTE_TEXT._nowrap(true);
};
_me.__print = function(aValues){

	if (aValues.NOTES)
		aValues.values.NOTE_TEXT = aValues.NOTES[0].values.NOTE_TEXT;
	
	aValues = aValues.values;

	if (!gui.print)
		gui._create('print','frm_print');

	gui.print._template('print_note',aValues);
};

_me.__loadItems = function() {
	var me = this;
	var tab1 = this.maintab.tab1;
	loadDataIntoForm(tab1,this._aValues);

	//Copy contact name into window title
	tab1.EVNTITLE._onkeyup = function(){
		var sTitle = this._value();
		if (sTitle){
			if (sTitle.length>32)
			    sTitle = sTitle.substr(0,32)+'...';

			me._title(sTitle,true);
		}
		else
		    me._title('NOTE::NOTE');
	};
	tab1.EVNTITLE._onkeyup();

	if (!this._aValues['EVN_ID']) tab1.EVNSHARETYPE._value(GWOthers.getItem('DEFAULT_CALENDAR_SETTINGS','note_sharing'));
	
	//Fill NOTE_TEXT (because it is stored as addon)
	try{
		this.maintab.tab1.NOTE_TEXT._value(this._aValues.NOTES[0].values.NOTE_TEXT || '');
	}
	catch(er){}
	
	// TAB4 (attachments)
	if (this.maintab.tab2)
	this.maintab.tab2._onactive = function (bFirstTime) {
		if (bFirstTime){
			if (me._aValues['ATTACHMENTS']){
				var out = [];
				for (var i in me._aValues['ATTACHMENTS'])
					out.push({'name': me._aValues['ATTACHMENTS'][i]['values']['ATTDESC'], 'class': me._aValues['ATTACHMENTS'][i]['values']['ATTTYPE'], 'id': i, 'fullpath': me._aValues.fullpath, 'size': me._aValues['ATTACHMENTS'][i]['values']['ATTSIZE']});

				if (me._aValues.fullpath)
					this.X_ATTACHMENTS._value({'values': out});
				else
					this.X_ATTACHMENTS._value({'path': me._sAccountID+'/'+me._sFolderID+'/'+WMItems.__serverID(me._sItemID), 'values': out});
			}
			else
			if (me._aValues['PUSH_ATTACHMENTS'])
		        this.X_ATTACHMENTS._value({path:me._aValues['PUSH_ATTACHMENTS'][0]['fullpath'].substr(0,me._aValues['PUSH_ATTACHMENTS'][0]['fullpath'].lastIndexOf('/')),
											values:[{
												'name': me._aValues['PUSH_ATTACHMENTS'][0]['title'],
												'id': me._aValues['PUSH_ATTACHMENTS'][0]['id'],
												'size': me._aValues['PUSH_ATTACHMENTS'][0]['size'],
												'class': me._aValues['PUSH_ATTACHMENTS'][0]['embedded'] ? 'item' : 'itemlink',
												'fullpath': me._aValues['PUSH_ATTACHMENTS'][0]['fullpath']
											}]});
		}
	}

	if (this.maintab['public'])
		this.maintab['public']._onactive = function (bFirstTime){
			if (bFirstTime){
				this.X_TICKET._onclick = function(){
		        	this._setRange(0,this._value().length);
				};
				this.X_TICKET._readonly(true);
				this.X_TICKET._value(me._aValues.TICKET);
			}
		};

	if (me._aValues['PUSH_ATTACHMENTS'] && this.maintab.tab2)
		this.maintab.tab2._active();
};

_me.__saveItems = function(aValues) {
	var addon;
	if (this.maintab.tab2 && this.maintab.tab2.X_ATTACHMENTS && !Is.Empty(addon = this.maintab.tab2.X_ATTACHMENTS._value()))
		aValues['ATTACHMENTS'] = addon;

	//Save NOTE_TEXT (because it is stored as addon)
	aValues['NOTES'] = [{values:{NOTE_TEXT:this.maintab.tab1.NOTE_TEXT._value()}}];

	if (!aValues.values.EVNTITLE && aValues.values.NOTE_TEXT)
		aValues.values.EVNTITLE = aValues.values.NOTE_TEXT.length>128?aValues.values.NOTE_TEXT.substr(0,128)+'...':aValues.values.NOTE_TEXT;
	
	delete aValues.values.NOTE_TEXT;
};
