_me = frm_task.prototype;
function frm_task(){};

_me.__constructor = function() {
	var me = this;

	this._defaultSize(-1,-1,600,470);

    var aData = {};
	var tmpf = Path.split(this._sFolderID)[0];
    if (dataSet.get('folders',[this._sAccountID,tmpf,'TYPE'])=='A')
		aData.owner = tmpf;
	else
	    aData.owner = this._sAccountID;

	if (this._aValues.TICKET)
        aData.ticket_url = true;
        
	this._draw('frm_task', 'main', aData);
	this.__initForm('TASK::TASK');

	var tab1 = this.maintab.tab1;

	if (!this._sItemID) {
		tab1.EVNSTARTDATE._disabled(true);
		tab1.EVNENDDATE._disabled(true);
	}
	
	tab1.X_EVNCOMPLETE._fill({'0':'0','25':'25','50':'50','75':'75','100':'100'});


	tab1.X_STARTS._onclick = function() {
		tab1.EVNSTARTDATE._disabled(!this._value());
		if (this._value())
			tab1.EVNSTARTDATE._ondateselect();
	};
	tab1.X_ENDS._onclick = function() {
		tab1.EVNENDDATE._disabled(!this._value());
		if (this._value())
			tab1.EVNENDDATE._ondateselect();
	};

    tab1.EVNSTARTDATE._ondateselect = function(){
		var tmp0 = this._getObjectDate();
		var tmp1 = this._parent.EVNENDDATE._getObjectDate();
		
		if (!this._parent.EVNENDDATE._disabled() && tmp0 && tmp1 && tmp0.getTime() < tmp1.getTime())
			this._parent.EVNENDDATE._value(this._value(), true);
	};
    tab1.EVNENDDATE._ondateselect = function(){
		var tmp0 = this._getObjectDate();
		var tmp1 = this._parent.EVNSTARTDATE._getObjectDate();
		
		if (!this._parent.EVNSTARTDATE._disabled() && tmp0 && tmp1 && tmp0.getTime() > tmp1.getTime())
			this._parent.EVNSTARTDATE._value(this._value(), true);
	};


	tab1.EVNSTATUS._onchange = function() { me.__setEvncomplete(); }
	tab1.X_EVNCOMPLETE._onchange = function() { me.__setEvnstatus(); }
	
};

_me.__print = function(aValues){
	aValues = aValues.values;
   	aValues.COUNT_DATE = '';

	if (aValues.EVNENDDATE>0){
        var t = new Date();
		t.setGWTime(aValues.EVNENDDATE,0);
        aValues.COUNT_DATE = t.toWMString(true);

	}
	if (aValues.EVNSTARTDATE>0){
        var t = new Date();
		t.setGWTime(aValues.EVNSTARTDATE,0);
		aValues.COUNT_DATE += ' - ' + t.toWMString(true);
	}

	if (!gui.print)
		gui._create('print','frm_print');

	gui.print._template('print_task',aValues);
};

_me.__setEvncomplete = function(sValue){
	var tab1 = this.maintab.tab1;

	switch (tab1.EVNSTATUS._value()[0]){
		case 'B':
			tab1.X_EVNCOMPLETE._value(0);
			tab1.X_EVNCOMPLETE._disabled(true);
			break;
		case 'M':
			tab1.X_EVNCOMPLETE._value(100);
			tab1.X_EVNCOMPLETE._disabled(true);
			break;
		default:
			if (Is.Defined(sValue)) tab1.X_EVNCOMPLETE._value(sValue);
			tab1.X_EVNCOMPLETE._disabled(false);
			break;
	}
};

_me.__setEvnstatus = function() {
	var tab1 = this.maintab.tab1;
	var curval = parseInt(tab1.X_EVNCOMPLETE._value());
	
	if (!Is.Number(curval) || curval <= 0)
		tab1.EVNSTATUS._value('B');
	else
	if (curval >= 100)
		tab1.EVNSTATUS._value('M');
};

_me.__loadItems = function() {
	var me = this;

	var tab1 = this.maintab.tab1;
	loadDataIntoForm(tab1,this._aValues);

	//Copy contact name into window title
	tab1.EVNTITLE._onkeyup = function(){
		var sTitle = this._value();
		if (sTitle){
			if (sTitle.length>32)
			    sTitle = sTitle.substr(0,32)+'...';

			me._title(sTitle,true);
		}
		else
		    me._title('TASK::TASK');
	};
	tab1.EVNTITLE._onkeyup();
	
	if (Is.Defined(this._aValues['EVNSTARTDATE']) && this._aValues['EVNSTARTDATE'] != 'undefined' && this._aValues['EVNSTARTDATE'] != 0) {
		tab1.X_STARTS._value(true);
		tab1.EVNSTARTDATE._disabled(false);
	} else {
		tab1.X_STARTS._value(false);
		tab1.EVNSTARTDATE._value('empty');
		tab1.EVNSTARTDATE._disabled(true);
	}
	if (Is.Defined(this._aValues['EVNENDDATE']) && this._aValues['EVNENDDATE'] != 'undefined' && this._aValues['EVNENDDATE'] != 0) {
		tab1.X_ENDS._value(true);
		tab1.EVNENDDATE._disabled(false);
	} else {
		tab1.X_ENDS._value(false);
		tab1.EVNENDDATE._value('empty');
		tab1.EVNENDDATE._disabled(true);
	}
	
	if (inArray(['B','I', 'M', 'Q', 'N'], this._aValues['EVNSTATUS']) == -1)
		tab1.EVNSTATUS._value('B');
		
	this.__setEvncomplete(this._aValues['EVNCOMPLETE']);

	if (typeof this._aValues['EVNPRIORITY'] == 'undefined') tab1.EVNPRIORITY._value('0');
	
	if (!this._aValues['EVN_ID']) tab1.EVNSHARETYPE._value(GWOthers.getItem('DEFAULT_CALENDAR_SETTINGS','task_sharing'));
	
	if (Is.Defined(this._aValues['REMINDERS']))
		tab1.X_REMINDERS._value(this._aValues['REMINDERS']);

	
	// TAB2 (recurrence)
	this.maintab.tab2._onactive = function (bFirstTime) {
		if (bFirstTime) {
			var recurrence = shiftObject(me._aValues['RECURRENCES']);
			if (recurrence != null)
				this.X_REPEATING._value(recurrence);
				
			if (Is.Defined(me._aValues['EVNENDDATE'])) {
				var rawDate = parseJulianDate(me._aValues['EVNENDDATE']); 
				var date = new Date(rawDate.year, rawDate.month-1, rawDate.day);
				this.X_REPEATING._setDate(date);
			}
		}
	}
	
	// TAB5 (Attendee)
	this.maintab.tab5._onactive = function (bFirstTime) {
		if (bFirstTime){
			if (Is.Defined(me._aValues['CONTACTS']))
				this.X_ATTENDEES._value(me._aValues['CONTACTS']);
			
			if (me._aValues['EVNFLAGS']&1)
				this.X_ATTENDEES.invitation._value(1);
			else
			if (me._aValues['EVNFLAGS']&2)
				this.X_ATTENDEES.invitation._disabled(true);
		}
	}

	// TAB4 (attachments)
	if (this.maintab.tab4)
	this.maintab.tab4._onactive = function (bFirstTime) {
		if (bFirstTime){
			if (me._aValues['ATTACHMENTS']){

				var out = [];
				for (var i in me._aValues['ATTACHMENTS'])
					out.push({'name': me._aValues['ATTACHMENTS'][i]['values']['ATTDESC'], 'class': me._aValues['ATTACHMENTS'][i]['values']['ATTTYPE'], 'id': i, 'fullpath': me._aValues.fullpath, 'size': me._aValues['ATTACHMENTS'][i]['values']['ATTSIZE']});

				if (me._aValues.fullpath)
					this.X_ATTACHMENTS._value({'values': out});
				else
					this.X_ATTACHMENTS._value({'path': me._sAccountID+'/'+me._sFolderID+'/'+WMItems.__serverID(me._sItemID), 'values': out});
			}
			else
			if (me._aValues['PUSH_ATTACHMENTS'])
		        this.X_ATTACHMENTS._value({path:me._aValues['PUSH_ATTACHMENTS'][0]['fullpath'].substr(0,me._aValues['PUSH_ATTACHMENTS'][0]['fullpath'].lastIndexOf('/')),
											values:[{
												'name': me._aValues['PUSH_ATTACHMENTS'][0]['title'],
												'id': me._aValues['PUSH_ATTACHMENTS'][0]['id'],
												'size': me._aValues['PUSH_ATTACHMENTS'][0]['size'],
												'class': me._aValues['PUSH_ATTACHMENTS'][0]['embedded'] ? 'item' : 'itemlink',
												'fullpath': me._aValues['PUSH_ATTACHMENTS'][0]['fullpath']
											}]});
		}
	}

	if (this.maintab['public'])
		this.maintab['public']._onactive = function (bFirstTime){
			if (bFirstTime){
				this.X_TICKET._onclick = function(){
		        	this._setRange(0,this._value().length);
				};
				this.X_TICKET._readonly(true);
				this.X_TICKET._value(me._aValues.TICKET);
			}
		};

	if (me._aValues['PUSH_ATTACHMENTS'] && this.maintab.tab4)
		this.maintab.tab4._active();
};

_me.__saveItems = function(aValues) {
	var tab1 = this.maintab.tab1;
	if (!tab1.X_STARTS._value()) aValues['values']['EVNSTARTDATE'] = 0;
	if (!tab1.X_ENDS._value()) aValues['values']['EVNENDDATE'] = 0;
	aValues['values']['EVNSTARTTIME'] = -1;
	aValues['values']['EVNENDTIME'] = -1;
	aValues['values']['EVNCOMPLETE'] = tab1.X_EVNCOMPLETE._value();
	
	var addon;
	if (!Is.Empty(addon = tab1.X_REMINDERS._value()))
		aValues['REMINDERS'] = addon;

	// TAB2
	if (aValues.values.EVNENDDATE && this.maintab.tab2.X_REPEATING && !Is.Empty(addon = this.maintab.tab2.X_REPEATING._value()))
		aValues['RECURRENCES'] = [addon];
	else
	if (!aValues.values.EVNENDDATE && this._aValues && this._aValues.EVNRCR_ID)
    	aValues['RECURRENCES'] = [{uid:this._aValues.EVNRCR_ID}];

	// TAB4
	if (this.maintab.tab4 && this.maintab.tab4.X_ATTACHMENTS && !Is.Empty(addon = this.maintab.tab4.X_ATTACHMENTS._value()))
		aValues['ATTACHMENTS'] = addon;
		
	// TAB5
	if (this.maintab.tab5.X_ATTENDEES){
		if (!Is.Empty(addon = this.maintab.tab5.X_ATTENDEES._value()))
			aValues['CONTACTS'] = addon;
			
		if (!this.maintab.tab5.X_ATTENDEES.invitation._disabled()){
			aValues['values'].EVNFLAGS = this.maintab.tab5.X_ATTENDEES.invitation._value()?1:'';
			//aValues['values'].EVNORGANIZER = this.__owner;
		}
	}
};