_me = obj_attach_mailview.prototype;
function obj_attach_mailview(){};

_me.__constructor = function(){
    this.__idtable = [];

	this.__eAttach = document.getElementById(this._anchors['attach']);

	if (this.__eAttach){
		var me = this;
		this.__eAttach.onclick = function(e){
	         var e = e || window.event;
	         var elm = e.target || e.srcElement;
	             elm = elm.parentNode;
			 if (elm.tagName != 'A') return false;

			 var id = me.__getId(elm.id);
			 if (me._onclick) me._onclick(e,elm,id,me.__idtable[id]);

			 me.__exeEvent('onclick',e,{"arg":me.__idtable[id],"elm":elm,"id":id,"owner":me});

			 return false;
		};

	    this.__eAttach.oncontextmenu = this.__eAttach.onclick;
		this.__eAttach.ondblclick 	 = this.__eAttach.onclick;
	}
};

_me._value = function(v){
	if (v && Is.Array(v['attachments']))
		for (var i in v['attachments'])
			this._add(v['attachments'][i]);
};

_me._add = function(aArg){
	this.__idtable.push(aArg);
	this._addGuiElement(aArg, this.__idtable.length-1);
};

_me._addGuiElement = function(aArg,id) {
	if (!this.__eAttach) return;

	var att = mkElement('a',{"href":'',"id":this.__getElmId(id)});

	if (aArg.css)
		att.className = aArg.css;

	if (aArg.size)
		att.innerHTML = '<span>' + aArg.name +' ('+ parseFileSize(aArg.size) +');'+ '</span>';
	else
		att.innerHTML = '<span>' + aArg.name +';'+ '</span>';

	this.__eAttach.appendChild(att);

	if (this._onchange) this._onchange();
};

   /**
    * @brief: return DOM Element ID
    **/
   _me.__getElmId = function (id){
	  return this._pathName +'/'+ id;
   };
   /**
    * @brief: return obj ID
    **/
   _me.__getId = function (eid){
	  return eid.substr(this._pathName.length+1);
   };

/**
 * @date : 14.7.2006 10:26:59
 **/
_me._onclick = function(e,elm,id,arg){

	if (e.type == 'contextmenu'){
		var cmenu = gui._create("cmenu","obj_context",'','',this);

        var aMenu = [];

        if (arg.type == 'certificate'){
			aMenu.push(
				{"title":'ATTACHMENT::SAVE','arg':[this,'_save_cert',[this._fullpath()]]},
				{"title":'ATTACHMENT::SHOW_CERT','arg':[this,'_open_cert',[arg]]},
				{"title":'ATTACHMENT::APPEND_CERT','arg':[Item.addCert,[[this._aid,this._fid,this._iid]]]});
		}
		else{
	        if (arg.type && arg.type.toLowerCase().indexOf('message/rfc822')===0)
	        	aMenu.push({"title":'ATTACHMENT::OPEN_WINDOW','arg':[this,'_open', [this._aid,this._fid,this._iid+'|'+arg.id]]});

			aMenu.push(
				{"title":'ATTACHMENT::SAVE','arg':[this,'_save',[this._fullpath(arg['id'])]]},
				{"title":'ATTACHMENT::SAVE_ALL','arg':[this,'_saveAll',[this._fullpath()]]});

			if (sPrimaryAccountGW>0){
	            var dgw = GWOthers.getItem('RESTRICTIONS', 'disable_gw_types');
	            if (!dgw || dgw.indexOf('f')<0){
	                aMenu.push(
						{"title":'-'},
						{"title":'ATTACHMENT::SAVE_TO_FOLDER','arg':[this,'_saveFolder',[{'name':arg['name'],'size':arg.size,'fullpath':this._fullpath(arg['id'])}]]});
				}
			}
		}

		cmenu._fill(aMenu);
		cmenu._place(e.clientX,e.clientY);
	}
	else
	if (arg.type && arg.type.toLowerCase().indexOf('message/rfc822') === 0){

		var pos,sID = '';
		if ((pos = this._iid.indexOf('|'))<0)
			sID = this._iid+'|'+arg.id;
		else
		    sID = this._iid.substr(0,pos+1)+arg.id;

		this._open(this._aid,this._fid,sID);
	}
	else
	if (arg.type && arg.type == 'certificate')
        this._open_cert(arg);
	else
		this._save(this._fullpath(arg['id']));
};

_me._fullpath = function(attId) {
	return this._aid+'/'+this._fid+'/'+WMItems.__serverID(this._iid) + (Is.Defined(attId)?'/'+attId:'');
};

_me._open_cert = function (arg){
    if (arg && arg.cert && arg.cert.INFO)
		gui._create('certificate','frm_certificate','','',arg.cert.INFO[0]);
};

_me._open = function(aid,fid,iid){
	OldMessage.openwindow([aid,fid,iid]);
};

//download.php?sid={sid}&class=email_certificate&fullpath={account}/{folder}/{item}
_me._save_cert = function(sFullPath){
	var aUrl = {'sid':dataSet.get('main',['sid']),'class':'email_certificate','fullpath':sFullPath};
	downloadItem(buildURL(aUrl));
};

_me._save = function(sFullPath) {
	var aUrl = {'sid':dataSet.get('main',['sid']),'class':'attachment','fullpath':sFullPath};
	downloadItem(buildURL(aUrl));
};

_me._saveAll = function(sFullPath) {
	var aUrl = {'sid':dataSet.get('main',['sid']),'class':'allattachments','fullpath':sFullPath};
	downloadItem(buildURL(aUrl));
};

_me._saveFolder = function(arg){
	var fid = Mapping.getDefaultFolderForGWType('F'),
		att = {};
		att[arg.fullpath.substr(arg.fullpath.lastIndexOf('/')+1)] = {values:{'ATTTYPE':'attachment','ATTDESC':arg.name,'ATTSIZE':arg.size}};
	
	Item.open([sPrimaryAccount,fid],null,{aid:sPrimaryAccount,fid:fid,'fullpath':arg.fullpath,'ATTACHMENTS':att},'F');
};