_me = obj_upload_edit_select.prototype;
function obj_upload_edit_select(){};


_me.__constructor = function(){
	var me = this;
	this.__atts = {};
    this.__idtable = [];
    
	this.attachments.__sortColumn = 'name';
	this.attachments._addColumns({name:{title:"DATAGRID_ITEMS_VIEW::EVNFILENAME",width:400,arg:{sort:'asc'}},size:{title:"DATAGRID_ITEMS_VIEW::EVNFILESIZE",width:100,arg:{sort:'asc'}}});

	this.attachments._ondblclick = function(e,elm,arg,id){
		if (typeof id != 'undefined') me._save(id);
	};

	this.attachments._oncontext = function(e,elm,arg,sLineId,sColumn){
		//Klikly jsme na místo bez položek?
		if (typeof sLineId == 'undefined') return;

		gui._create("cmenu","obj_context",'','',me);
		var aMenu = [{"title":'ATTACHMENT::SAVE','arg':[me,'_save',[sLineId]]},
			 {"title":'ATTACHMENT::SAVE_ALL','arg':[me,'_save',[]],disabled:me.__disable_save_all},
			 {"title":'ATTACHMENT::REMOVE','arg':[me,'_remove',[sLineId]]}];

		gui.cmenu._fill(aMenu);
		gui.cmenu._place(e.clientX,e.clientY);
	};

	this.add_item._onclick = function() { gui._create('insert_item', 'frm_insert_item', '', '', [me, '__addItems']); };
	this.remove._onclick = function() { me.__deleteItems(me.attachments._value()); };
	
	////// FILE //////
	this.file._onuploadstart = function(){
		me.__disable_save_all = true;
	};
	this.file._onuploadsuccess = function(file){
		me._add(file);
	};
	this.file._onuploadend = function (){
		me.__disable_save_all = false;
	};
};

_me._value = function(v){
	if (typeof v == 'undefined'){
		var out = [];

		for (var i in this.__idtable)
			if ((this.__idtable[i]['class'] == 'attachment' || this.__idtable[i]['class'] == 'P' || this.__idtable[i]['class'] == 'itemlink') && !this.__idtable[i]['fullpath']){
				if (this.__idtable[i]['removed'])
				    out.push({uid:this.__idtable[i].id});
			}
			else
			if (!this.__idtable[i]['removed'])
				out.push({values:{'class':this.__idtable[i]['class'] || 'file',description:this.__idtable[i]['name'],fullpath:this.__idtable[i]['fullpath'] || ((this.__idtable[i]['folder'] || this.file._getFolder())+"/"+this.__idtable[i]['id'])}});

		return out;
	}
	else{
		if (v.path)
	        this.file._setFolder(v.path);

	    if (v.values)
			for(var i in v.values)
                this.__idtable.push(v.values[i]);

        this.__fillDataGrid();
	}
};

_me._add = function(aArg){

	if (!aArg.fullpath)
		aArg.folder = this.file._getFolder();

	aArg['class'] = aArg['class'] || 'file';

	this.__idtable.push(aArg);
    
	//Add gui element
    this.__fillDataGrid();
};

_me._remove = function (id){
	if (typeof id == 'undefined'){
	    for(var i in this.__idtable)
	        this._remove(i);
	}
	else
	if (this.__idtable[id] && !this.__idtable[id].removed){
		this.__idtable[id].removed = true;

		this.__fillDataGrid();
	}
};

_me.__fillDataGrid = function(){
	var aData = {};
	for (var i in this.__idtable)
		if (!this.__idtable[i]['removed'])
			aData[i] = {id:i,data:{name:this.__idtable[i].name,size:[parseFileSize(this.__idtable[i].size || 0),parseInt(this.__idtable[i].size || 0)]},arg:{id:i}};

	this.attachments._serverSort(aData);
};

_me.__deleteItems = function(aIDs) {
	for (var i in aIDs)
	    this._remove(aIDs[i]);
};


_me._save = function(id) {
	//Save ALL
	if (typeof id == 'undefined'){
		var aUrl = {'sid':dataSet.get('main',['sid']),'class':'allattachments','fullpath':this.file._getFolder()};
		downloadItem(buildURL(aUrl));
	}
	else{
		var sClass = this.__idtable[id]['class'] || 'file';
	    var sFullPath = '';

		switch (sClass) {
			case 'P':
			     sClass = 'attachment';
			case 'file':
			case 'url':
			case 'item':
			case 'attachment':
				sFullPath = this.__idtable[id]['fullpath'] || ((this.__idtable[id]['folder'] || this.file._getFolder())+'/'+this.__idtable[id]['id']);
				break;
			case 'itemlink':

				var aValues;
				var sAccount;
				var sFolder;
				var sItem;
				var aPath;

				//Just Added (has it's original fullpath)
				if (this.__idtable[id]['fullpath']){
                    aPath = this.__splitFullPath(this.__idtable[id]['fullpath']);
                    
					aValues = WMItems.list({"aid": aPath[0], "fid": aPath[1], "iid": aPath[2]})[aPath[0]][aPath[1]][aPath[2]];
					sAccount = aPath[0];
					sFolder = aPath[1];
					sItem = aPath[2];
				}
				//Already saved
				else{
                    var aPath = this.__splitFullPath(this.file._getFolder());
                    aValues = WMItems.list({"aid": aPath[0], "fid": aPath[1], "iid": aPath[2], "atid": this.__idtable[id].id});
					for (sAccount in aValues)
						for (sFolder in aValues[sAccount])
							for (sItem in aValues[sAccount][sFolder]);

					aValues = aValues[sAccount][sFolder][sItem];
				}
				var sFolderType = dataSet.get("folders", [sAccount, sFolder, 'TYPE']);
				gui._create('gw', Mapping.getFormNameByGWType(sFolderType), '', '', sAccount, sFolder, sItem, aValues);

				return;
		}

		if (sFullPath) {
			var aUrl = {'sid': dataSet.get('main', ['sid']), 'class': sClass, 'fullpath': sFullPath};
			downloadItem(buildURL(aUrl));
		}
	}
};
	_me.__splitFullPath = function(sPath) {

		var aRet = [];
		var nIndex;

		if ((nIndex = sPath.indexOf('/')) >= 0) {
			aRet[0] = sPath.substring(0, nIndex);
			sPath = sPath.substring(nIndex+1);
		} else return [];

		if ((nIndex = sPath.lastIndexOf('/')) >= 0) {
		    aRet[2] = sPath.substring(nIndex+1);
			sPath = sPath.substring(0, nIndex);
		} else return [];

		aRet[1] = sPath;

		return aRet;
	};

_me.__addItems = function(aItems) {

	for (var i in aItems) {
		var out = {
				'name': aItems[i]['title'],
				'id': aItems[i]['id'],
				'size': aItems[i]['size'],
				'class': aItems[i]['type'] || (aItems[i]['embedded'] ? 'item' : 'itemlink'),
				'fullpath': aItems[i]['fullpath']
			};
			
		if (out['class'] == 'item')
			for (var j in this.__idtable)
				if (this.__idtable[j]['id'] == aItems[i]['id'] && this.__idtable[j]['class'] == 'item')
					continue;

		this._add(out);
	}
};